!===============================================================================
! pulsar.forpulsar
!===============================================================================
! Copyright (C) 2006-2013 Christian Fernandez, Jean-Paul Amoureux
! JPA - Unite de Catalyse et Chimie du Solide, Lille, France.
! CF  - Laboratoire Catalyse et Spectrochimie, Caen, France.  
!       christian.fernandez@ensicaen.fr
! This software is governed by the CeCILL-B license under French law 
! and abiding by the rules of distribution of free software.  
! You can  use, modify and/ or redistribute the software under 
! the terms of the CeCILL-B license as circulated by CEA, CNRS and INRIA
! at the following URL "http://www.cecill.info".
! See Licence.txt in the main masai source directory
!===============================================================================

include "diagonalize.f90" 
include "util.f90"
include "parameters.f90"
include "share.f90"
include "operators.f90"
include "ll.f90"
include "main.f90"

!===============================================================================
program Main
  ! This main program will not be used 
  ! as a librairy (so, pyd, dll ...) will be created with f2y
end program
!===============================================================================

	

!===============================================================================
! pulsar.parameters
!===============================================================================
! Copyright (C) 2006-2013 Christian Fernandez, Jean-Paul Amoureux
! JPA - Unite de Catalyse et Chimie du Solide, Lille, France.
! CF  - Laboratoire Catalyse et Spectrochimie, Caen, France.
!       christian.fernandez@ensicaen.fr
! This software is governed by the CeCILL-B license under French law
! and abiding by the rules of distribution of free software.
! You can  use, modify and/ or redistribute the software under
! the terms of the CeCILL-B license as circulated by CEA, CNRS and INRIA
! at the following URL "http://www.cecill.info".
! See Licence.txt in the main masai source directory
!===============================================================================


module parameters

! This module is the interface used by pulsar to pass parameters between pulsar 
! and the calling python program


  implicit none

                                                 ! info debugging
                                                 !---------------
  integer*8 :: exception=-1
  character(LEN=256) :: exception_text=" "

  integer*8 :: CRITICAL,ERROR,WARNING,INFO, VERBOSE,DEBUG
  parameter (CRITICAL=1)
  parameter (ERROR=2)
  parameter (WARNING=3)
  parameter (INFO=4)
  parameter (VERBOSE=5)
  parameter (DEBUG=6)
  integer*8 :: loglevel=INFO

                                                 !---------------------------------------------------------
                                                 ! very important: to be used in conjunction with python,
                                                 ! all static variables must be initialized...
                                                 ! for an unknown reason,
                                                 ! if the variable are not initialized or initialised to zero,
                                                 ! the passing of values between python and fortran doesn't work
                                                 ! (at least on my window system: to check on linux)
                                                 !---------------------------------------------------------

                                                 ! useful constants
                                                 ! ----------------
  real*8 :: pi
  real*8 :: sq6
  real*8 :: eps
  real*8 :: twopi
  real*8 :: twopim6
  character(len=2)  :: crlf=char(13)//char(10)
  character(len=2)  :: tab=char(09)
  character(len=32) :: underline
  parameter (underline="--------------------------------")

  parameter (pi=3.1415926535897932384626433832795d0)
  parameter (sq6=2.4494897427831780981972840747059d0)
  parameter (eps=1.0d-17)
  parameter (twopi=6.283185307179586476925286766559d0)
  parameter (twopim6=0.000006283185307179586476925286766559d0)


  character (len=32768) :: message
  character (len=255)  :: message_fmt


                                                 !limits for array allocations
                                                 !----------------------------
  integer*8 :: nptsmax=16384
  integer*8 :: accuracymax=16

                                                 !spectrometer
                                                 !------------
  real*8 :: spectrometerfield=2.3d0              !spectrometer field
  real*8 :: protonfrequency=100.d0               !proton frequency

                                                 !probehead
                                                 !---------
  real*8 :: spinningangle=eps                    !spinner  angle / bo
  real*8 :: spinningspeed=eps                    !spinner frequency
  real*8 :: qfactor=0.001                        !probe quality q-factor (f.w.h.m=wo/q_factor)

                                                 !spin_system
                                                 !-----------
  real*8, dimension(:,:), allocatable :: nucleus             !nucleus 'x_n'
  real*8, dimension(:,:), allocatable :: chemicalshift       !iso, csa, eta, euler angles
  real*8, dimension(:,:), allocatable :: indirect            !i, j, jcoupling  (note: jcoupling is a reserved keyword in f2py cannot be used here)
  real*8, dimension(:,:), allocatable :: dipole              !i, j, dipole, euler angles
  real*8, dimension(:,:), allocatable :: quadrupole          !quadrupolar constant, eta, euler angle and distribution
  real*8, dimension(:,:), allocatable :: t2                  !t2 homogeneous relaxation time

                                                 !simulation_parameters
                                                 !---------------------
  integer*8 :: accuracy=1                        !accuracy on euler angles (1-16)
  real*8    :: rfstep=5.d0                        !rf integration step
  integer*8 :: nsb=10                            !number of sidebands
  integer*8 :: npts=512                          !spectrum points number
  real*8    :: sw=10000.d0                       !total spectral width
  real*8    :: sr=eps
  integer*8 :: ncycles=1                         !number of period (pulse+delay) in the sequence
  integer*8 :: nall=999                          !undefined=999, all transitions :0, central: 1, satellite: 2
                                                 !pulses
                                                 !------
  real*8, dimension(:), allocatable :: pulseangle            !pulse angle
  real*8, dimension(:,:), allocatable :: pulse               !pulse definition
  real*8, dimension(:,:), allocatable :: delay               !delay definition
  real*8, dimension(:,:), allocatable :: coher               !phase selection and coherence jump
  real*8, dimension(:,:), allocatable :: ctp                 !pathways selection list

                                                 !final simulation arrays
                                                 !-----------------------
  complex*8, dimension(:), allocatable :: spec               !spectrum
  complex*8, dimension(:,:), allocatable :: ros              !density matrix for the spin s
  complex*8, dimension(:,:), allocatable :: roi              !density matrix for the spin i

                                                 !phases  (to be supressed later)
                                                 !------
  integer*8 :: nboucle=-1                        !index of the pulse where a ctp merging occurs
  integer*8 :: ifasing=1                         !flag to say if a phase cycling is used or not (by default phase cycling is used)

  integer*8, dimension(:), allocatable :: nphase             !number of phase for each pulse  (2pi/nphase phase cycling)
  integer*8, dimension(:), allocatable :: level              !selected coherence level after each pulse (during a phase cycling)
  integer*8, dimension(:,:), allocatable :: qu1              !selected coherence in a direct selection in the density matrix
  integer*8, dimension(:,:), allocatable :: qu2              !a second coherence with may be also retained
  integer*8, dimension(:), allocatable :: iref

  logical*8 :: idealpulse=.true.
  logical*8 :: zerospectrum=.true.                         ! the spectrum memo
  real*8 :: rcph=0.0d0                                ! receiver phase

  logical*8 :: keepgoing=.true.
  logical*8 :: spectrum_compute=.true.

  ! if czjzek is set to true the quadrupolar constant is replaced by a distribution of values
  ! following the czjzek distribution probability
  logical*8 :: czjzek= .false.

end module parameters

!-------------------------------------------------
subroutine reset_parameters()
!-------------------------------------------------
! Initialisation of the main parameters and arrays
!-------------------------------------------------
  use parameters

  message=''
  message_fmt=''
  nptsmax=16384
  accuracymax=16
  spectrometerfield=2.3d0
  protonfrequency=100.0d0
  spinningangle=0.0d0
  spinningspeed=0.0d0
  qfactor=0.001
  if (allocated(nucleus)) deallocate(nucleus)
  if (allocated(chemicalshift)) deallocate (chemicalshift)
  if (allocated(indirect)) deallocate (indirect)
  if (allocated(dipole)) deallocate (dipole)
  if (allocated(quadrupole)) deallocate (quadrupole)
  if (allocated(t2)) deallocate (t2)
  accuracy=1
  rfstep=5.0
  nsb=0.0D0
  npts=512
  sw=10000.0
  sr=0.0
  ncycles=1
  nall=0
  if (allocated (pulseangle)) deallocate(pulseangle)
  if (allocated (pulse)) deallocate(pulse)
  if (allocated (delay)) deallocate(delay)
  if (allocated (coher)) deallocate(coher)
  if (allocated (ctp)) deallocate(ctp)
  if (allocated (spec)) deallocate (spec)
  if (allocated (ros)) deallocate (ros)
  if (allocated (roi)) deallocate (roi)
  nboucle=-1
  ifasing=1
  if (allocated (nphase)) deallocate (nphase)
  if (allocated (level)) deallocate (level)
  if (allocated (qu1)) deallocate (qu1)
  if (allocated (qu2)) deallocate (qu2)
  if (allocated (iref)) deallocate (iref)
  idealpulse=.true.

end subroutine reset_parameters

!===============================================================================
! pulsar.ll
!===============================================================================
! Copyright (C) 2006-2013 Christian Fernandez, Jean-Paul Amoureux
! JPA - Unite de Catalyse et Chimie du Solide, Lille, France.
! CF  - Laboratoire Catalyse et Spectrochimie, Caen, France.  
!       christian.fernandez@ensicaen.fr
! This software is governed by the CeCILL-B license under French law 
! and abiding by the rules of distribution of free software.  
! You can  use, modify and/ or redistribute the software under 
! the terms of the CeCILL-B license as circulated by CEA, CNRS and INRIA
! at the following URL "http://www.cecill.info".
! See Licence.txt in the main masai source directory
!===============================================================================


logical*8 function isnull(angle)
!-------------------------------
  implicit none

  real*8 angle(0)

  real*8 eps
  parameter(eps=1.0d-30)

  isnull=.false.
  if (max(abs(maxval(angle)),abs(minval(angle))).le.eps) isnull=.true.

end function isnull


subroutine ll(xx,yy,zz,ii,jj,r3)
!-------------------------------

  use share
  use operators
  use diagonalize

  implicit none

                                                 ! args
                                                 !-----
  real*8, intent(in) :: xx
  real*8, intent(in) :: yy
  real*8, intent(in) :: zz
  integer*8, intent(in) :: ii
  integer*8, intent(in) :: jj
  real*8, intent(in) :: r3

                                                 ! external function
                                                 !------------------
!  interface isnull
!    logical*8 function isnull(angle)
!      real*8 :: angle(:)
!      logical*8 :: isnull
!    end function
!  end interface

  external isnull
  logical*8 :: isnull

                                                 ! loop counters
  integer*8 :: i,j,k,l, kk
  integer*8 :: insb,ig,nc
  integer*8 :: itp, ib, ictp

                                                 ! other parameters
  real*8 :: cb
  real*8 :: sb
  real*8 :: ca
  real*8 :: sa
  real*8 :: c2a
  real*8 :: s2a
  real*8 :: rrrr
  integer*8 :: ins

  real*8    :: ddm
  real*8    :: gam
  real*8    :: arg
  !integer*8 :: nphi
  real*8    :: tat
  real*8    :: tp
  real*8    :: dtpp


  real*8    :: v0qi
  real*8    :: v0qs
  real*8    :: v0ci
  real*8    :: v0dcs
  real*8    :: v0dip
  real*8    :: tetaf
  real*8    :: ctetaf
  real*8    :: stetaf
  real*8    :: v0qis
  real*8    :: v0qii
  real*8    :: v0dcis
  real*8    :: v0cii
  real*8    :: tetai
  real*8    :: dtetai
  real*8    :: dtetaf
  real*8    :: cteta
  real*8    :: steta
  real*8    :: vpij
  real*8    :: dvpij
  real*8    :: cvp
  real*8    :: svp
  integer*8 :: indi
  integer*8 :: indj
  !real*8    :: divise
  real*8    :: gt
  real*8    :: arg2
  complex*8    :: args
  complex*8 :: signal
  real*8    :: dem
  complex*8 :: recph


  cb=zz
  sb=sqrt(abs(1.0d0-zz*zz))
  if(abs(sb)>eps) then
    ca=xx/sb
    sa=yy/sb
    c2a=(xx*xx-yy*yy)/sb/sb
    s2a=2.0d0*xx*yy/sb/sb
  else
    ca=1.0d0
    sa=0.0d0
    c2a=1.0d0
    s2a=0.0d0
  end if
  

                                                 ! calculation of the am
                                                 !-----------------------
  ats=cmplx(0.0d0,0.0D0)
  aqi=cmplx(0.0d0,0.0D0)
  aci=cmplx(0.0d0,0.0D0)
  aqs=cmplx(0.0d0,0.0D0)
  acs=cmplx(0.0d0,0.0D0)
  ads=cmplx(0.0d0,0.0D0)
  p=cmplx(0.0d0,0.0D0)
  q=cmplx(0.0d0,0.0D0)

  if(abs(coefps).gt.eps) call am(etaqs,aqs)

  if(abs(csas).gt.eps) then
    if(isnull(csangle)) then
      call am(etacs,acs)
    else
      call amdif(r2mcs,acs)
    end if
  end if
  
  
  if (kcoupled>0) adks=0.0d0
  do ins=1,kcoupled
    if(abs(dipk(ins)).ge.0.1) then
      if (isnull(dskangle(ins,:))) then
         call am(0.0d0, adks(ins,:))             ! we fill first the adks array
      else
         call amdif(r2mdsk(ins,:),adks(ins,:))
      end if
    end if
  end do

  do l=0,2
    ats(l)=sq6*csas*acs(l)                       ! then we create the ats array
    do ins=1,kcoupled
      ats(l)=ats(l)+sq6*dipk(ins)*adks(ins,l)
    end do
  end do

  if(abs(dsi).gt.eps.and.icoupled.gt.0) then
    if(isnull(dsiangle)) then
      call am(0.0d0,ads)
    else
      call amdif(r2mdsi,ads)
    end if
  end if

  if(abs(coefpi).gt.eps.and.icoupled.gt.0) then
    if (isnull(qiangle)) then
      call am(etaqi,aqi)
    else
      call amdif(r2mqi,aqi)
    end if
  end if

  if(abs(csai).gt.eps.and.icoupled.gt.0) then
    if (isnull(ciangle)) then
      call am(etaci, aci)
    else
      call amdif(r2mci,aci)
    end if
  end if
  
  aqss=cmplx(0.0d0,0.0D0)
  acspi=cmplx(0.0d0,0.0D0)
  aqsi=cmplx(0.0d0,0.0D0)
  aqpi=cmplx(0.0d0,0.0D0)
  aqps=cmplx(0.0d0,0.0D0)
  adcps=cmplx(0.0d0,0.0D0)
  adipolis=cmplx(0.0d0,0.0D0)

  do l=0,4
    if (staticsample.and.(l.ne.0)) cycle
    rrrr=zl(l)*de(l,0)
    aqpi(l)=rrrr*aqi(l)
    acspi(l)=rrrr*aci(l)*sq6*csai
    adipolis(l)=rrrr*ads(l)*sq6*dsi
    aqps(l)=rrrr*aqs(l)
    adcps(l)=rrrr*ats(l)
    do k=1,2
      do i=l-2,2
        aqsi(k,l)=aqsi(k,l)+zl(l)*dk(k,l,i)*aqi(i)*aqi(l-i)
        aqss(k,l)=aqss(k,l)+zl(l)*dk(k,l,i)*aqs(i)*aqs(l-i)
      end do
    end do
  end do

                                                 ! wr(ii,jj,k) and p(k,nsbs) are independant of gamma and of the phase cycling
                                                 ! so they are calculated once only for each crystal orientations.

  a=cmplx(0.0d0,0.0D0)
  do k=1,ns-1
    ddm=3.0d0*(2.0d0*dble(k)-2.0d0*spins-1.0d0)*coefps
    wr(ii,jj,k)=isost+real(u1s(k)*aqss(1,0)+u2s(k)*aqss(2,0)+adcps(0)-ddm*aqps(0))
    if(staticsample) cycle
    do l=1,4
      a(k,l)= (u1s(k)*aqss(1,l)+u2s(k)*aqss(2,l)+adcps(l)-ddm*aqps(l))/wm(l)! complex a correspond to the previous ab and bb
    end do
  end do

  gam=-dg
  do i=1,ng
    gam=gam+dg
    do k=1,ns-1
      arg=0.0d0
      do l=1,4
        arg=arg+real(a(k,l))*dsin(l*gam)-aimag(a(k,l))*dcos(l*gam)
      end do
      do insb=-nsb,nsb
        p(k,insb)=p(k,insb)+cmplx(dcos(arg-dble(insb)*gam),dsin(arg-dble(insb)*gam))
      end do
    end do
  end do

  gam=-dg
  tat=0.0d0
  
  ! loop on gamma angles
  ! --------------------
  loop_gamma: do ig=1,ng
    
    gam=gam+dg
    

    ! loop on the coherence selection (min of ntcp is one)
    !-----------------------------------------------------
    loop_ctp: do ictp=1,nctp

      ! initial reduced density matrix
      !-------------------------------
      ro=sz+iz*vli/vls

      tat=0.0d0

      ! loop on the preparation period
      !-------------------------------
      loop_ncycles: do nc=1,ncycles

        !TENTATIVE: CASE OF IDEAL PULSE ON S
        if (idealpulse.AND.nc.EQ.1) then
           ro=-cmplx(0.,sy)
        end if

        if ((.not.idealpulse)) then          !TODO add pulseangle parameter
                                             !and make possible to have more than one idealpulse in the sequence

          ! period with rf-fields
          !----------------------
          tp=-deltatp(nc)*twopim6/2.0d0

                                                   !   lorsque le pulse est court (<1 tour), tri et tii ne servent � rien : matrices identit�es
                                                   !   lorsque le pulse est long  (>1 tour), tri et tii ont �t� r�-initialis�es (280) et servent
                                                   !   de point de d�part pour le dernier petit pas de pulse.

          ui=cmplx(unity)                            ! initialize to the identity matrix

                                                   ! pulse-decomposition in small rf-steps
                                                   !--------------------------------------
          loop_ntp: do itp=1,ntp(nc)

            dtpp=deltatp(nc)*twopim6
            tp=tp+dtpp

            if(itour(nc).ge.0.and.itp.eq.ntp(nc)) then
                                                   ! dans le cas o� le pulse est plus long qu'un tour, on traite � la  fin le dernier petit pulse
              dtpp=deltatpadd(nc)*twopim6
              if(dtpp.lt.0.0000001d0) cycle loop_ntp
              tp=rflength(nc)*twopim6-dtpp/2.0d0
            end if

            v0qi=real(aqpi(0))
            v0qs=real(aqps(0))
            v0ci=real(acspi(0))
            v0dcs=real(adcps(0))
            v0dip=real(adipolis(0))
            vvi(:)=real(aqsi(:,0))
            vvs(:)=real(aqss(:,0))

            if (.not.staticsample) then
                                                   ! voir le probleme de la multiplication par *twopim6  (unite)
              do l=1,4
                tetaf=wm(l)*(tat+tp)+l*gam
                ctetaf=dcos(tetaf)
                stetaf=dsin(tetaf)
                v0qi=v0qi+real(aqpi(l))*ctetaf+aimag(aqpi(l))*stetaf
                v0qs=v0qs+real(aqps(l))*ctetaf+aimag(aqps(l))*stetaf
                v0ci=v0ci+real(acspi(l))*ctetaf+aimag(acspi(l))*stetaf
                v0dcs=v0dcs+real(adcps(l))*ctetaf+aimag(adcps(l))*stetaf
                v0dip=v0dip+real(adipolis(l))*ctetaf+aimag(adipolis(l))*stetaf
                vvi(:)=vvi(:)+real(aqsi(:,l))*ctetaf+aimag(aqsi(:,l))*stetaf
                vvs(:)=vvs(:)+real(aqss(:,l))*ctetaf+aimag(aqss(:,l))*stetaf
              end do

            end if

            htst= cmplx(   (isoi-rfoffseti(nc)+v0ci)*iz                       &! real part
                         + (isost-rfoffsets(nc)+v0dcs)*sz                     &
                         + (v0dip+jsi)*sziz                                   &
                         + coefpi*v0qi*iq                                     &
                         + coefps*v0qs*sq                                     &
                         + coefsi*(vvi(1)*iq1+vvi(2)*iq2)                     &
                         + coefss*(vvs(1)*sq1+vvs(2)*sq2)                     &
                         + rfpoweri(nc)*ix*dcos(rfphasei(nc))                 &
                         + rfpowers(nc)*sx*dcos(rfphases(nc))                 &
                       ,   rfpoweri(nc)*iy*dsin(rfphasei(nc))                 &! imaginary
                         + rfpowers(nc)*sy*dsin(rfphases(nc)) )


            ! diagonalization
            !----------------
            call diag(nsi,htst,vp,z)

            ! calculation of u+.ro(t).u
            !--------------------------
            expvp=0.0d0
            do i=1,nsi
              expvp(i,i)=cmplx(dcos(vp(i)*dtpp),dsin(vp(i)*dtpp))! exp(i*vp)
            end do
            y=matmul(z,expvp)                      ! y=z*exp(i*vp)
            u=matmul(y,transpose(conjg(z)))        ! u=y.z+

            uf=matmul(ui,u)                        ! uf=ui.u

            if(itp.eq.ntpadd(nc)) uint=uf
            ! storage of the intermediate evolution operator in the case where the "pulselength > rotorperiod"

            ! pulselength > rotorperiod
            !--------------------------
            if(itour(nc).ge.0.and.itp.eq.(ntp(nc)-1)) then

              usi=uf
              usf=uf

                                                   !   � la fin du 1� tour,on calcule la matrice densit� correspondant � itour+1 tours
                                                   !   entiers: c'est la puissance itour+1 de celle correspondant � 1 tour.
                                                   !   on doit donc remultiplier itour fois celle correspondant � 1 tour.
              do ib=1,itour(nc)
                uf = matmul(usf,usi)
                usf = uf
              end do

                                                   !   apr�s itour+1 il y a un reste, dont la 1� partie correspond � ntpint pas de dur�e dtp.
                                                   !   l'op�rateur d'�volution correspondant � ces ntpint pas, a �t� stoqu� -> uint
              if(ntpadd(nc).gt.0) uf = matmul(usf,uint)

            end if

                                                   ! here we are, except for the last small pulse fraction
                                                   !------------------------------------------------------
            ui=uf                                  ! on red�marre de l� pour traiter ce dernier petit pulse: on repart � loop_ntp

          end do loop_ntp

          rot=matmul(ro,uf)
          ro=matmul(transpose(conjg(uf)),rot)

        end if ! idealpulse

        ! period without rf-field and no homonuclear dipolar couplings
        ! (todo : make a test to replace by a pulse in this case)
        !-------------------------------------------------------------

        if (rfdelay(nc).gt.eps) then

          v0qis= real(aqps(0))*rfdelay(nc)*twopim6
          v0qii= real(aqpi(0))*rfdelay(nc)*twopim6
          v0dcis= real(adcps(0))*rfdelay(nc)*twopim6
          v0cii= real(acspi(0))*rfdelay(nc)*twopim6
          v0dip= real(adipolis(0))*rfdelay(nc)*twopim6
          vvis(:)= real(aqss(:,0))*rfdelay(nc)*twopim6
          vvii(:)= real(aqsi(:,0))*rfdelay(nc)*twopim6

          if(.not.staticsample) then

            do l=1,4
              tetai=wm(l)*(tat+rflength(nc)*twopim6)+l*gam
              tetaf=tetai+wm(l)*rfdelay(nc)*twopim6
              dtetai=mod(tetai,twopi)
              dtetaf=mod(tetaf,twopi)
              cteta=(dcos(dtetaf)-dcos(dtetai))/wm(l)
              steta=(dsin(dtetaf)-dsin(dtetai))/wm(l)
              v0qis=v0qis+real(aqps(l))*steta-aimag(aqps(l))*cteta
              v0qii=v0qii+real(aqpi(l))*steta-aimag(aqpi(l))*cteta
              v0dcis=v0dcis+real(adcps(l))*steta-aimag(adcps(l))*cteta
              v0cii=v0cii+real(acspi(l))*steta-aimag(acspi(l))*cteta
              v0dip=v0dip+real(adipolis(l))*steta-aimag(adipolis(l))*cteta
              vvis(:)=vvis(:)+real(aqss(:,l))*steta-aimag(aqss(:,l))*cteta
              vvii(:)=vvii(:)+real(aqsi(:,l))*steta-aimag(aqsi(:,l))*cteta
            end do

          end if                                 ! not static sample

          htsr= 0.0d0
          htsr=    ((isost-rfoffsets(nc))*rfdelay(nc)*twopim6+v0dcis)*sz  &
                 + (( isoi-rfoffseti(nc))*rfdelay(nc)*twopim6+v0cii)*iz   &
                 + decouple(nc)*(v0dip+jsi*rfdelay(nc)*twopim6)*sziz      &
                 + coefps*v0qis*sq                                        &
                 + coefpi*v0qii*iq                                        &
                 + coefss*(vvis(1)*sq1+vvis(2)*sq2)                       &
                 + coefsi*(vvii(1)*iq1+vvii(2)*iq2)


          do i=1,nsi
            do j=1,nsi
              vpij=htsr(i,i)-htsr(j,j)
              dvpij=mod(vpij,twopi)
              cvp=dcos(dvpij)
              svp=dsin(dvpij)
              ro(i,j)=ro(i,j)*cmplx(cvp,-svp)
            end do
          end do

        end if                                   ! rfdelays

        ! effect of t2 on each coherences
        !--------------------------------
        if (t2si(nc).le.0.99999999.or.t2ss(nc).le.0.99999999.or.t2ii(nc).le.0.99999999) then
          do i=1,nsi
            do j=1,nsi
              indi=int((i-1)/ns)
              indj=int((j-1)/ns)
              if(indi.eq.indj.and.i.ne.j) ro(i,j)=ro(i,j)*t2ss(nc)
              if(indi.ne.indj) then
                if((i-j).eq.(ns*((i-j)/ns))) then
                  ro(i,j)=ro(i,j)*t2ii(nc)
                else
                  ro(i,j)=ro(i,j)*t2si(nc)
                end if
              end if
            end do
          end do
        end if

        ! Coherence filtering  (up to now, only on the spin S)
        ! TODO : allow also a selection on spin I
        !-----------------------------------------------------
       
        if (allocated(ctp))then
          if (nc.ne.ncycles.AND.abs(nint(ctp(ictp,nc+1))).lt. 999) then
                                                                   ! pass if ctp doesn't exist or if it is the last pulse
                                                                   ! in the latter case we don't care about selecting something
                                                                   ! (the receiver select -1 anyway)

          ! we first store the roI density matrix for spin I, because it must remain unaffected by the selection on spin S
          !--------------------------------------------------------------------------------------------------------------
          sti=0.0d0
          if (ni>1) then
            do i=1,ni
              do j=1,ni
                do kk=1,ns
                  sti(i,j)=sti(i,j)+ro(kk+(i-1)*ns,kk+(j-1)*ns)/dble(ns)
                                                   !
                                                   ! TODO : check this (because the sum of the diagonal element is not zero
                                                   ! when there is no I spin?)
                end do
              end do
            end do
          end if

                                                   ! when we make a selection directly in the density matrix (for instance on the spin S),
                                                   ! we must keep the coherences ((mS+p,mI),(mS,mI)), so with mI kept constant. this is checked using
                                                   ! two parameters indi and indj

          do i=1,nsi
            do j=1,nsi
              indi=int((i-1)/ns)                    ! these two lines calculate the corresponding index on spin I (mI)
              indj=int((j-1)/ns)

              ! the selection must be done at mI constant, and thus when indi=indj
              ! the corresponding element is kept
              !--------------------------------------------------------------------

              ! we use nc+1 because the list ctp have its first element to 0 (before the first pulse)

                if((indi.eq.indj).AND.((j-i).eq.Nint(ctp(ictp,nc+1)))) then
                  cycle
                END if

             ! if ( abs(nint(ctp(ictp,nc+1))-10000) .lt. 999) then
             !   ! case of the pathway compression (symetrical pathways)
             !
             !   if(indi.eq.indj.and.abs(j-i).eq.abs(nint(ctp(ictp,nc+1))-10000)) cycle
             !
             ! end if

              ! if it is a non selected coherence, then it is set to 0
              !-------------------------------------------------------
              ro(i,j)=0.0d0

              ! now restore roI constant for all values of mS corresponding to identical values of mI.
              !---------------------------------------------------------------------------------------
              if((i-j).eq.(ns*((i-j)/ns))) ro(i,j)=sti(indi+1,indj+1)
            end do
          end do

         end if 
        end if ! test allocation of ctp
 
        tat=tat+(rflength(nc)+rfdelay(nc))*twopim6

      ! goto the calculation of the next pulse+delay
      !---------------------------------------------

      end do loop_ncycles

      !store the density matrix for the given CTP
      !------------------------------------------
      roctp(ictp,:,:)=ro(:,:)

    ! go to the calculation of the next CTP
    !-------------------------------------
    end do loop_ctp


    ! we compute the sum of the different CTP (sum along the dimension 1 of roctp)
    !-----------------------------------------------------------------------------
    ro=SUM(roctp,DIM=1)/DBLE(nctp)

    ! we compute the total density matrix weighted (R3) by the polar angle.
    !----------------------------------------------------------------------

    rott=rott+ro/r3

    ! End of the preparation period
    !------------------------------
    gt=spinningspeed*tat+gam
    do k=1,ns-1
      arg2=0.0d0
      do l=1,4
        arg2=arg2+aimag(a(k,l))*dcos(l*gt)-real(a(k,l))*dsin(l*gt)
      end do
      do insb=-nsb,nsb
        args=cmplx(dcos(arg2+insb*gt),dsin(arg2+insb*gt))
        signal=0.0d0
        do kk=0,ni-1
          signal=signal+ro(k+1+kk*ns,k+kk*ns)
        end do
        q(k,insb)=q(k,insb)+signal*args
      end do
    end do

  end do loop_gamma

  if (spectrum_compute) then

    ! observation period : sx et -sy
    !-------------------------------
    recph=exp(cmplx(0.d0,(rcph-90.)*pi/180.0d0))     ! apply receiver phase -90 when rcph=0.
    do k=1,ns-1
      do insb=-nsb,nsb
        dem=dnorm*sx(k,k+1)/(1.0d0+qq*(wr(ii,jj,k)+dble(insb)*spinningspeed)**2)/r3
        qt(ii,jj,k,insb)=qt(ii,jj,k,insb)+q(k,insb)
        amp(ii,jj,k,insb)=conjg(p(k,insb)*qt(ii,jj,k,insb))*dem
        amp(ii,jj,k,insb)=amp(ii,jj,k,insb)*recph
      end do
    end do

  END if

  contains
  !------------------------!
  ! ll internal procedures !
  !------------------------!
    subroutine am(eta,aa)
    !--------------------
      implicit none

      complex*8 :: aa(-4:4)
      real*8 :: eta

      aa(-2)= cmplx(sb*sb/2.0d0 -eta*(1.0d0+cb*cb)*c2a/6.0d0, -eta*cb*s2a/3.0d0)
      aa(-1)= cmplx(-sb*cb*(eta*c2a/3.0d0+1.0d0), -eta*sb*s2a/3.0d0)
      aa(0) = cmplx((3.0d0*cb*cb-1.0d0 -eta*sb*sb*c2a)/sq6)
      aa(1) =-conjg(aa(-1))
      aa(2) = conjg(aa(-2))

    end subroutine am

    subroutine amdif(r2m,aa)
    !-----------------------
      implicit none

      complex*8 :: aa(-4:4)
      complex*8 :: r2m(0:2)
      real*8 :: sq15
      parameter(sq15=1.2247448713915890490986420373529d0)
      real*8 :: fgm1,fgm2,fgp1,fgp2

      fgm1=ca*real(r2m(1))-sa*aimag(r2m(1))
      fgm2=c2a*real(r2m(2))-s2a*aimag(r2m(2))
      fgp1=ca*aimag(r2m(1))+sa*real(r2m(1))
      fgp2=c2a*aimag(r2m(2))+s2a*real(r2m(2))

      aa(0)=  cmplx((3.0d0*zz*zz-1.0d0)*real(r2m(0))/2.0d0+sq15*sb*(sb*fgm2-2.0d0*zz*fgm1))
      aa(1)=  cmplx(sb*zz*(sq15*real(r2m(0))-fgm2)+(2.0d0*zz*zz-1.0d0)*fgm1, sb*fgp2-zz*fgp1)
      aa(2)=  cmplx((sq15*sb*sb*real(r2m(0))+(1.0d0+zz*zz)*fgm2)/2.0d0+sb*zz*fgm1, -zz*fgp2-sb*fgp1)
      aa(-2)= conjg(aa(2))
      aa(-1)=-conjg(aa(1))

    end subroutine amdif

end subroutine ll

!===============================================================================
! pulsar.diagonalize
!===============================================================================
! Copyright (C) 2006-2013 Christian Fernandez, Jean-Paul Amoureux
! JPA - Unite de Catalyse et Chimie du Solide, Lille, France.
! CF  - Laboratoire Catalyse et Spectrochimie, Caen, France.  
!       christian.fernandez@ensicaen.fr
! This software is governed by the CeCILL-B license under French law 
! and abiding by the rules of distribution of free software.  
! You can  use, modify and/ or redistribute the software under 
! the terms of the CeCILL-B license as circulated by CEA, CNRS and INRIA
! at the following URL "http://www.cecill.info".
! See Licence.txt in the main masai source directory
!===============================================================================


module diagonalize
!-----------------

  real*8, dimension(:), allocatable, save :: e 
  real*8, dimension(:,:), allocatable, save :: tau 
  real*8, dimension(:,:), allocatable, save :: hr 
  real*8, dimension(:,:), allocatable, save :: hi 
  real*8, dimension(:,:), allocatable, save :: zr 
  real*8, dimension(:,:), allocatable, save :: zi 


  contains

    subroutine dealloc()
    !-------------------

      if (allocated(e)) deallocate (e)
      if (allocated(tau)) deallocate (tau)
      if (allocated(hr)) deallocate (hr)
      if (allocated(hi)) deallocate (hi)
      if (allocated(zr)) deallocate (zr)
      if (allocated(zi)) deallocate (zi)

    end subroutine dealloc

    subroutine diag(n,hts,vp,z)
    !--------------------------
      integer*8 :: n
      real*8    :: vp(n)
      complex*8 :: z(n,n)
      complex*8 :: hts(n,n)

      integer*8 :: i

      if (.not.allocated(e)) allocate (e(n))
      if (.not.allocated(tau)) allocate (tau(2,n))
      if (.not.allocated(hr)) allocate (hr(n,n))
      if (.not.allocated(hi)) allocate (hi(n,n))
      if (.not.allocated(zr)) allocate (zr(n,n))
      if (.not.allocated(zi)) allocate (zi(n,n))

      vp=0.0d0
      zr=0.0d0
      zi=0.0d0
      do i=1,n
        zr(i,i)=1.0d0
      end do
      hr=real(hts)
      hi=aimag(hts)
                                                 ! todo: make the SUBROUTINEs handling complex arrays
      call htridi(n,hr,hi,vp,e,tau)
      call tql2(n,vp,e,zr)
      call htribk(n,hr,hi,tau,zr,zi)

      hts=cmplx(hr,hi)
      z=cmplx(zr,zi)

    end subroutine diag

    subroutine htridi(n,htsr,htsi,vp,e,tau)
    !--------------------------------------
      integer*8 :: n
      real*8    :: htsr(n,n)
      real*8    :: htsi(n,n)
      real*8    :: vp(n)
      real*8    :: e(n)
      real*8    :: tau(2,n)
      real*8 eps
      parameter(eps=1.0d-30)

      integer*8 :: i,j,ii,l,k,jp1
      real*8    :: h,g,scal,f,si,gi,hh,fi

      tau(1,n)=1.
      tau(2,n)=0.
      do 100 i=1,n
    100 vp(i)=htsr(i,i)
      do 300 ii=1,n
        i=n+1-ii
        l=i-1
        h=0.
        scal=0.
        if(l.lt.1) goto 130
        do 120 k=1,l
    120 scal=scal+abs(htsr(i,k))+abs(htsi(i,k))
        if(abs(scal).gt.eps) goto 140
        tau(1,l)=1.
        tau(2,l)=0.
    130 e(i)=0.
        goto 290
    140 do 150 k=1,l
            htsr(i,k)=htsr(i,k)/scal
            htsi(i,k)=htsi(i,k)/scal
    150 h=h+htsr(i,k)*htsr(i,k)+htsi(i,k)*htsi(i,k)
        g=sqrt(h)
        e(i)=scal*g
        f=cabs(cmplx(htsr(i,l),htsi(i,l)))
        if(abs(f).lt.eps) goto 160
        tau(1,l)=(htsi(i,l)*tau(2,i)-htsr(i,l)*tau(1,i))/f
        si=(htsr(i,l)*tau(2,i)+htsi(i,l)*tau(1,i))/f
        h=h+f*g
        g=1.+g/f
        htsr(i,l)=g*htsr(i,l)
        htsi(i,l)=g*htsi(i,l)
        if(l.eq.1) goto 270
        goto 170
    160 tau(1,l)=-tau(1,i)
        si=tau(2,i)
        htsr(i,l)=g
    170 f=0.
        do 240 j=1,l
        g=0.
        gi=0.
        do 180 k=1,j
        g=g+htsr(j,k)*htsr(i,k)+htsi(j,k)*htsi(i,k)
    180 gi=gi-htsr(j,k)*htsi(i,k)+htsi(j,k)*htsr(i,k)
        jp1=j+1
        if(l.lt.jp1) goto 220
        do 200 k=jp1,l
        g=g+htsr(k,j)*htsr(i,k)-htsi(k,j)*htsi(i,k)
    200 gi=gi-htsr(k,j)*htsi(i,k)-htsi(k,j)*htsr(i,k)
    220 e(j)=g/h
        tau(2,j)=gi/h
    240 f=f+e(j)*htsr(i,j)-tau(2,j)*htsi(i,j)
        hh=f/(h+h)
        do 260 j=1,l
        f=htsr(i,j)
        g=e(j)-hh*f
        e(j)=g
        fi=-htsi(i,j)
        gi=tau(2,j)-hh*fi
        tau(2,j)=-gi
        do 260 k=1,j
        htsr(j,k)=htsr(j,k)-f*e(k)-g*htsr(i,k)+fi*tau(2,k)+gi*htsi(i,k)
    260 htsi(j,k)=htsi(j,k)-f*tau(2,k)-g*htsi(i,k)-fi*e(k)-gi*htsr(i,k)
    270 do 280 k=1,l
        htsr(i,k)=scal*htsr(i,k)
    280 htsi(i,k)=scal*htsi(i,k)
        tau(2,l)=-si
    290 hh=vp(i)
        vp(i)=htsr(i,i)
        htsr(i,i)=hh
    300 htsi(i,i)=scal*sqrt(h)

    end subroutine htridi

    subroutine tql2(n,vp,e,z)
    !------------------------
      integer*8 :: n
      real*8    :: vp(n)
      real*8    :: e(n)
      real*8    :: z(n,n)

      integer*8 :: i,j,l,m, l1, mml, ii, k
      real*8    :: zachep,f,b,h,g,r,c,s,p

      zachep=2.**(-26)
      do 100 i=2,n
    100  e(i-1)=e(i)
      f=0.
      b=0.
      e(n)=0.
      do 240 l=1,n
       j=0
       h=zachep*(abs(vp(l))+abs(e(l)))
       if(b.lt.h) b=h
        do 110 m=l,n
    110     if(abs(e(m)).le.b) goto 120
    120     if(m.eq.l) goto 220
    130     if(j.eq.30) print *, "There is a big problem in 'htridi'"
            j=j+1
            l1=l+1
            g=vp(l)
            p=(vp(l1)-g)/(2.*e(l))
            r=sqrt(p*p+1.)
            vp(l)=e(l)/(p+sign(r,p))
            h=g-vp(l)
            do 140 i=l1,n
    140     vp(i)=vp(i)-h
            f=f+h
            p=vp(m)
            c=1.
            s=0.
            mml=m-l
            do 200 ii=1,mml
               i=m-ii
               g=c*e(i)
               h=c*p
               if(abs(p).lt.abs(e(i))) goto 150
               c=e(i)/p
               r=sqrt(c*c+1.)
               e(i+1)=s*p*r
               s=c/r
               c=1./r
               goto 160
    150        c=p/e(i)
               r=sqrt(c*c+1.)
               e(i+1)=s*e(i)*r
               s=1./r
               c=c*s
    160        p=c*vp(i)-s*g
               vp(i+1)=h+s*(c*g+s*vp(i))
               do 180 k=1,n
                  h=z(k,i+1)
                  z(k,i+1)=s*z(k,i)+c*h
    180           z(k,i)=c*z(k,i)-s*h
    200     continue
            e(l)=s*p
            vp(l)=c*p
            if(abs(e(l)).gt.b) goto 130
    220     vp(l)=vp(l)+f
    240  continue
         do 300 ii=2,n
            i=ii-1
            k=i
            p=vp(i)
            do 260 j=ii,n
               if(vp(j).ge.p) goto 260
               k=j
               p=vp(j)
    260     continue
            if(k.eq.i) goto 300
            vp(k)=vp(i)
            vp(i)=p
            do 280 j=1,n
               p=z(j,i)
               z(j,i)=z(j,k)
               z(j,k)=p
    280     continue
    300  continue

    end subroutine tql2

    subroutine htribk(n,htsr,htsi,tau,zr,zi)
    !---------------------------------------
      integer*8 :: n
      real*8    :: htsr(n,n)
      real*8    :: htsi(n,n)
      real*8    :: tau(2,n)
      real*8    :: zr(n,n)
      real*8    :: zi(n,n)
      real*8 eps
      parameter(eps=1.0d-30)

      integer*8 :: k,i,j,l
      real*8    :: h,s,si

      do 50 k=1,n
          do 50 j=1,n
          zi(k,j)=-zr(k,j)*tau(2,k)
  50      zr(k,j)=zr(k,j)*tau(1,k)
       do 140 i=2,n
          l=i-1
          h=htsi(i,i)
          if (abs(h).lt.eps) goto 140            ! (h.eq.0.0)
          do 130 j=1,n
             s=0.
             si=0.
             do 110 k=1,l
                s=s+htsr(i,k)*zr(k,j)-htsi(i,k)*zi(k,j)
  110           si=si+htsr(i,k)*zi(k,j)+htsi(i,k)*zr(k,j)
             s=s/h/h
             si=si/h/h
             do 120 k=1,l
                zr(k,j)=zr(k,j)-s*htsr(i,k)-si*htsi(i,k)
  120           zi(k,j)=zi(k,j)-si*htsr(i,k)+s*htsi(i,k)
  130     continue
  140  continue

    end subroutine htribk

end module diagonalize

!===============================================================================
! pulsar.util
!===============================================================================
! Copyright (C) 2006-2013 Christian Fernandez, Jean-Paul Amoureux
! JPA - Unite de Catalyse et Chimie du Solide, Lille, France.
! CF  - Laboratoire Catalyse et Spectrochimie, Caen, France.  
!       christian.fernandez@ensicaen.fr
! This software is governed by the CeCILL-B license under French law 
! and abiding by the rules of distribution of free software.  
! You can  use, modify and/ or redistribute the software under 
! the terms of the CeCILL-B license as circulated by CEA, CNRS and INRIA
! at the following URL "http://www.cecill.info".
! See Licence.txt in the main masai source directory
!===============================================================================


real*8 function radians(degrees)
!-------------------------------!
! conversion degrees to radians !
!-------------------------------!

  real*8,intent(in) :: degrees
  real*8 :: pi2
  parameter (pi2=0.017453292519943295769236907684886d0)
  radians=degrees*pi2
  return
end function radians

!logical*8 function isnull(angle)
!!-------------------------------
!  implicit none!
!
!  real*8 angle(:)!
!
!  real*8 eps
!  parameter(eps=1.0d-30)!
!
!  isnull=.false.
!  if (max(abs(maxval(angle)),abs(minval(angle))).le.eps) isnull=.true.
!
!end function isnull


subroutine wigner(angle,dw)
!-------------------------------------------!
! computation of the wigner matrix elements !
!-------------------------------------------!

  real*8, intent(in)  :: angle
  real*8, intent(inout) :: dw(-4:4,-4:4)

                                                 ! local variable
  real*8    :: c
  real*8    :: s

  real*8    :: sq38
  parameter ( sq38=0.61237243569579452d0 )

                                                 ! functions type declarations
  real*8    :: radians

  c=dcos(radians(angle))
  s=dsin(radians(angle))

  dw=0.0d0

  dw(-2,-2)=((1.0d0+c)**2)/4.0d0
  dw(2,2)=dw(-2,-2)
  dw(2,1)=-(1.0d0+c)*s/2.0d0
  dw(-2,-1)=-dw(2,1)
  dw(1,2)=-dw(2,1)
  dw(-1,-2)=dw(2,1)
  dw(2,0)=sq38*s*s
  dw(0,2)=dw(2,0)
  dw(-2,0)=dw(2,0)
  dw(0,-2)=dw(2,0)
  dw(2,-1)=-(1.0d0-c)*s/2.0d0
  dw(-1,2)=-dw(2,-1)
  dw(-2,1)=-dw(2,-1)
  dw(1,-2)=dw(2,-1)
  dw(2,-2)=((1.0d0-c)**2)/4.0d0
  dw(-2,2)=dw(2,-2)
  dw(1,1)=c*c-(1.0d0-c)/2.0d0
  dw(-1,-1)=dw(1,1)
  dw(1,-1)=(1.0d0+c)/2.0d0-c*c
  dw(-1,1)=dw(1,-1)
  dw(1,0)=-sq38*2.0d0*c*s
  dw(0,1)=-dw(1,0)
  dw(-1,0)=-dw(1,0)
  dw(0,-1)=dw(1,0)
  dw(0,0)=(3.0d0*c*c-1.0d0)/2.0d0

end subroutine wigner


subroutine orientate(euler,eta,r2m)
!------------------------------------------------------------!
! calculation of the r2m tensor components in a the m frame  !
!                                                            !
!      pas--(alpha,beta,gamma)-->mpas                        !
!                                                            !
!  mpas       2                             pas              !
! r       =  sum    d   (alpha,beta,gamma) r                 !
!  2m       m'=-2    m'm                    2m'              !
!------------------------------------------------------------!
  implicit none

                                                 ! args
  real*8, intent(in)  :: euler(3)
  real*8, intent(in)  :: eta
  complex*8, intent(out) :: r2m(0:2)
                                                 ! local
  real*8 :: dw(-4:4,-4:4)
  real*8 :: alpha, beta, gamma
  real*8 :: v2
  integer*2 :: m
  real*8 :: dm

  real*8 :: v0
  parameter (v0=0.81649658092772603273242802490196d0)! sqrt(2/3)

  real*8 :: radians

  alpha=radians(euler(1))
  beta=euler(2)                                  ! not yet converted to radians as the wigner function will do it
  gamma=radians(euler(3))

  v2=-eta/3.0d0                                  ! todo: why -eta/3 and not +eta

  call wigner(beta,dw)

  do m=1,2
    dm=dble(m)
    r2m(m)=cmplx(v0*dw(0,m)*dcos(dm*gamma)+ &
           v2*(dw(2,m)*dcos(dm*gamma+2.0d0*alpha)+dw(-2,m)*dcos(dm*gamma-2.0d0*alpha)), &
                 v0*dw(0,m)*dsin(dm*gamma)+ &
           v2*(dw(2,m)*dsin(dm*gamma+2.0d0*alpha)+dw(-2,m)*dsin(dm*gamma-2.0d0*alpha)))

  end do

  r2m(0)=cmplx(v0*dw(0,0)+2.0d0*v2*dw(2,0)*dcos(2.0d0*alpha))

end subroutine orientate

function num2str_i4n(i4n,fmat)
!-------------------------------------------
  implicit none
  integer*4, intent(in) :: i4n
  character(len=*), intent(in) ::  fmat
  character(len=32) ::  num2str_i4N
  integer*4 :: iochk
  num2str_i4n=''
  write(num2str_i4n,fmt=fmat,iostat=iochk) i4n
  if (iochk.ne.0) then
    num2str_i4n='# INVALID #'
  endif
  return
END function num2str_i4n

function num2str_i8n(i8n,fmat)
!-------------------------------------------
  implicit none
  integer*8, intent(in) :: i8n
  character(len=*), intent(in) ::  fmat
  character(len=32) ::  num2str_i8N
  integer*4 :: iochk
  num2str_i8n=''
  write(num2str_i8n,fmt=fmat,iostat=iochk) i8n
  if (iochk.ne.0) then
    num2str_i8n='# INVALID #'
  endif
  return
END function num2str_i8n

function num2str_r4n(r4n,fmat)
!-------------------------------------------
  implicit none
  real*4, intent(in) :: r4n
  character(len=*), intent(in) ::  fmat
  character(len=32) ::  num2str_r4N
  integer*4 :: iochk
  num2str_r4n=''
  write(num2str_r4n,fmt=fmat,iostat=iochk) r4n
  if (iochk.ne.0) then
    num2str_r4n='# INVALID #'
  endif
  return
END function num2str_r4n

function num2str_r8n(r8n,fmat)
!-------------------------------------------
  implicit none
  real*8 , intent(in) :: r8n
  character(len=*), intent(in) ::  fmat
  character(len=32) ::  num2str_r8N
  integer*4 :: iochk
!     erase any information in str.
  num2str_r8n=''
!     attempt to write i4n to str.
  write(num2str_r8n,fmt=fmat,iostat=iochk) r8n
  if (iochk.ne.0) then
!       invalid operation
    num2str_r8n='# INVALID #'
  endif
  return
END function num2str_r8n
!

!===============================================================================
! pulsar.operators
!===============================================================================
! Copyright (C) 2006-2013 Christian Fernandez, Jean-Paul Amoureux
! JPA - Unite de Catalyse et Chimie du Solide, Lille, France.
! CF  - Laboratoire Catalyse et Spectrochimie, Caen, France.  
!       christian.fernandez@ensicaen.fr
! This software is governed by the CeCILL-B license under French law 
! and abiding by the rules of distribution of free software.  
! You can  use, modify and/ or redistribute the software under 
! the terms of the CeCILL-B license as circulated by CEA, CNRS and INRIA
! at the following URL "http://www.cecill.info".
! See Licence.txt in the main masai source directory
!===============================================================================


module operators
!---------------
                                                 ! todo: make this module able to handle more than two nuclei
                                                 !
  implicit none

  real*8, allocatable    :: unity(:,:)           ! identity matrix

  real*8, allocatable    :: s2(:,:)              ! s^2
  real*8, allocatable    :: sx(:,:)              ! sx
  real*8, allocatable    :: sy(:,:)              ! sy
  real*8, allocatable    :: sz(:,:)              ! sz
  real*8, allocatable    :: sq(:,:)              ! 3sz^2-s^2
  real*8, allocatable    :: sq1(:,:)             ! sz(4s^2-8sz^2-1)/2
  real*8, allocatable    :: sq2(:,:)             ! sz(2s^2-2sz^2-1)/2
  real*8, allocatable    :: sp(:,:)              ! s+
  real*8, allocatable    :: sm(:,:)              ! s-

  real*8, allocatable    :: i2(:,:)              ! i^2
  real*8, allocatable    :: ix(:,:)              ! ix
  real*8, allocatable    :: iy(:,:)              ! iy
  real*8, allocatable    :: iz(:,:)              ! iz
  real*8, allocatable    :: iq(:,:)              ! 3iz^2-i^2
  real*8, allocatable    :: iq1(:,:)             ! iz(4i^2-8iz^2-1)/2
  real*8, allocatable    :: iq2(:,:)             ! iz(2i^2-2iz^2-1)/2
  real*8, allocatable    :: ip(:,:)              ! i+
  real*8, allocatable    :: im(:,:)              ! i-

  real*8, allocatable    :: sziz(:,:)            ! product iz*sz

END module

subroutine reset_operators()
!--------------------------

use share
use operators

implicit none

                                             !loop counters
  integer*8 :: i
  integer*8 :: j

  ! first deallocate the operators array if they are still allocated
  if (allocated(sz)) deallocate (sz)
  if (allocated(s2)) deallocate (s2)
  if (allocated(sx)) deallocate (sx)
  if (allocated(sy)) deallocate (sy)
  if (allocated(sq)) deallocate (sq)
  if (allocated(sq1)) deallocate (sq1)
  if (allocated(sq2)) deallocate (sq2)

  if (allocated(iz)) deallocate (iz)
  if (allocated(i2)) deallocate (i2)
  if (allocated(ix)) deallocate (ix)
  if (allocated(iy)) deallocate (iy)
  if (allocated(iq)) deallocate (iq)
  if (allocated(iq1)) deallocate (iq1)
  if (allocated(iq2)) deallocate (iq2)

  if (allocated(sziz)) deallocate (sziz)
  if (allocated(unity)) deallocate (unity)

  if (allocated(sp)) deallocate (sp)
  if (allocated(sp)) deallocate (sm)
  if (allocated(im)) deallocate (im)
  if (allocated(ip)) deallocate (ip)
  ns=nint(2.0d0*spins+1.0d0)
  ni=nint(2.0d0*spini+1.0d0)
  nsi=ns*ni

  allocate(unity(nsi,nsi))
  unity=0.0d0
  do j=1,ni
   do i=1,ns
     unity(i+(j-1)*ns,i+(j-1)*ns)=1.0d0
   end do
  end do

  allocate(sz(nsi,nsi))
  allocate(s2(nsi,nsi))
  allocate(iz(nsi,nsi))
  allocate(i2(nsi,nsi))
  sz=0.0d0
  s2=0.0d0
  iz=0.0d0
  i2=0.0d0
  do j=1,ni
    do i=1,ns
      s2(i+(j-1)*ns,i+(j-1)*ns)=spins*(spins+1.0d0)
      sz(i+(j-1)*ns,i+(j-1)*ns)=spins-dble(i-1)
      i2(i+(j-1)*ns,i+(j-1)*ns)=spini*(spini+1.0d0)
      iz(i+(j-1)*ns,i+(j-1)*ns)=spini-dble(j-1)
    end do
  end do
  allocate(sp(nsi,nsi))
  allocate(sm(nsi,nsi))
  allocate(sx(nsi,nsi))
  allocate(sy(nsi,nsi))
  allocate(sq(nsi,nsi))
  allocate(sq1(nsi,nsi))
  allocate(sq2(nsi,nsi))
  sp=0.0D0
  sm=0.0D0
  sp=cshift(sqrt(s2-matmul(sz,sz-unity)),-1,2) ! circular shift of unity row or one column to create s+ or s-
  sm=transpose(sp)
  sx=(sp+sm)/2.0d0
  sy=-(sp-sm)/2.0d0
  sq=3.0d0*matmul(sz,sz)-s2
  sq1=matmul(sz,4.0d0*s2-8.0d0*matmul(sz,sz)-unity)/2.0d0
  sq2=matmul(sz,2.0d0*s2-2.0d0*matmul(sz,sz)-unity)/2.0d0
  deallocate(sp)
  deallocate(sm)

  allocate(ip(nsi,nsi))
  allocate(im(nsi,nsi))
  allocate(ix(nsi,nsi))
  allocate(iy(nsi,nsi))
  allocate(iq(nsi,nsi))
  allocate(iq1(nsi,nsi))
  allocate(iq2(nsi,nsi))
  ip=0.0D0
  im=0.0D0
  ip=cshift(sqrt(i2-matmul(iz,iz-unity)),-ns,2)! circular shift of ns row or ns column to create i+ or i-
  im=transpose(ip)
  ix=(ip+im)/2.0d0
  iy=-(ip-im)/2.0d0
  iq=3.0d0*matmul(iz,iz)-i2
  iq1=matmul(iz,4.0d0*i2-8.0d0*matmul(iz,iz)-unity)/2.0d0
  iq2=matmul(iz,2.0d0*i2-2.0d0*matmul(iz,iz)-unity)/2.0d0
  deallocate(ip)
  deallocate(im)

  allocate (sziz(nsi,nsi))
  sziz=0.0D0
  sziz=matmul(sz,iz)

end subroutine reset_operators

!===============================================================================
! pulsar.main
!===============================================================================
! Copyright (C) 2006-2013 Christian Fernandez, Jean-Paul Amoureux
! JPA - Unite de Catalyse et Chimie du Solide, Lille, France.
! CF  - Laboratoire Catalyse et Spectrochimie, Caen, France.
!       christian.fernandez@ensicaen.fr
! This software is governed by the CeCILL-B license under French law
! and abiding by the rules of distribution of free software.
! You can  use, modify and/ or redistribute the software under
! the terms of the CeCILL-B license as circulated by CEA, CNRS and INRIA
! at the following URL "http://www.cecill.info".
! See Licence.txt in the main masai source directory
!===============================================================================

! TODO: Rewrite using less allocated arrays as this appear very time consuming

! reset ========================================================================
subroutine reset()
    ! Reset and deallocation of all arrays

    use diagonalize

    call dealloc()
    call reset_share()
    call reset_operators()
    call reset_parameters()

end subroutine reset
!===============================================================================

! compute ======================================================================
logical*1 function compute()
    ! main fonction called by python to compute a NMR spectra

    use operators
    use share

    implicit none

    ! function interfaces
    interface radians
        real*8 function radians(degrees)
            real*8,intent(in) :: degrees
        end function radians
    end interface

    interface wigner
        subroutine wigner(angle,dw)
        real*8, intent(in)  :: angle
        real*8, intent(inout) :: dw(-4:4,-4:4)
      end subroutine wigner
    end interface

    interface num2str
        function num2str_i4n(i4n,fmat)
        implicit none
        integer*4, intent(in) :: i4n
        character(len=*), intent(in) :: fmat
        character(len=32) num2str_i4n
      end function num2str_i4n
        function num2str_i8n(i8n,fmat)
        implicit none
        integer*8, intent(in) :: i8n
        character(len=*), intent(in) :: fmat
        character(len=32) num2str_i8n
      end function num2str_i8n
        function num2str_r4n(r4n,fmat)
        implicit none
        real*4, intent(in) :: r4n
        character(len=*), intent(in) :: fmat
        character(len=32) num2str_r4n
      end function num2str_r4n
        function num2str_r8n(r8n,fmat)
        implicit none
        real*8, intent(in) :: r8n
        character(len=*), intent(in) :: fmat
        character(len=32) num2str_r8n
      end function num2str_r8n
    end interface num2str

    ! loop index and flags
    integer*4 :: i=0
    integer*4 :: j=0
    integer*4 :: k=0
    integer*4 :: l=0
    integer*4 :: nc=0

    ! local parameters
    real*8    :: powder1=0.0d0
    real*8    :: powder2=0.0d0
    integer*8 :: inorm1(16)=(/2154752, 933774, 589820, 430020, &
                              338069, 278417, 236611, 205703, &
                              181927, 163068, 147749, 135059, &
                              124378, 115254, 107382, 100517/)
    integer*8 :: inorm2(16)=(/6122925, 3121593, 2088467, 1568265, &
                              1255355, 1046463, 897112, 785115, &
                              697918, 628170, 571061, 523524, &
                              483263, 448748, 418821, 392639/)
    real*8    :: rotorperiod=0.0d0 ! rotor period in usec (1e6/spinningspeed)
    real*8    :: rpf=0.0d0 ! rotor period fraction (due to rfstep)
    real*8    :: dms=0.0d0
    real*8    :: coefdip=0.0d0
    complex*8 :: tempr2m(0:2)=0.0d0
    real*8    :: tempangle(3)=0.0d0
    logical*8 :: wholesphere=.false.
    integer*8 :: nscans=1
    integer*8 :: ncoupled=0

    !----------------------------------------------!
    ! check parameters and prepare the calculation !
    !----------------------------------------------!

    ! check allocation of the parameters arrays
    ! in principle there is no need to do it here, as it is done by the python interface
    ! but I did it in the case where the program is used without python


    if (allocated(nucleus)) then
        if (size(nucleus,1).EQ.1) then
            if (allocated(indirect)) deallocate(indirect)
            if (allocated(dipole)) deallocate(dipole)
        end if
    else
        compute=.false.
        return
    end if

    !-------------------------------------------
    ! check if a sequence is defined...
    ! if it is not, there is no need to continue
    !-------------------------------------------
    if (allocated(pulse)) then
        ncycles=size(pulse,1)
    else
        compute=.false.
        return
    end if

    ! ------------------------------------------------
    ! Start evaluation of parameters and controls them
    ! ------------------------------------------------

    ! spectrometer
    ! TODO : Change the definition of NT and NG
    nt=5*accuracy
    powder1=dble(inorm1(nt/5))/1.0d7
    powder2=dble(inorm2(nt/5))/1.0d7

    ! spinning
    staticsample=.false.
    if(spinningangle.le.eps.or.spinningspeed.le.eps) then
        staticsample=.true.
        ng=1
        spinningangle=0.0d0
        spinningspeed=0.0d0
        nsb=0
    end if
    if (spinningspeed.gt.eps) then
        rotorperiod=1.0d6/spinningspeed ! in us
        ng=nint(sw/spinningspeed)+1
    else
        rotorperiod=1.0d30
    end if

    ng=max(nt,ng)
    dg=2.0d0*pi/dble(ng)
    ! cos and sin are not reconized by the linker when using f2py (on windows at least)
    ! (i don't know why as it works with g95: may be a problem with librairies)
    ! cos and sin are thus replaced by dcos and dsin (which means that all computations
    ! will be done in double-precision real*8)
    ! i decided to pass all arguments in double precision real*8 and integer*8 in the
    ! remaining of the program for sake of simplicity
    ! (may be this can be changed if there is a notable effect on speedness)
    de=0.0D0
    call wigner(spinningangle,de)

    do k=1,2
        do l=0,4
            do i=l-2,2
                dk(k,l,i)=de(i,k)*de(l-i,-k)
            end do
        end do
    end do

    ! spin system
    if (allocated(nucleus)) then
        spins=nucleus(1,2) ! spin of s
        vls=nucleus(1,3)   ! larmor of s (in hz)

        !-----------------------------------------------------------------------------
        !TODO: I have to CHECK if the sign of vls (gyromagnetic) may be usefull later!
        ! I didn't use it here due to the problems that arise in definition
        ! of chemical shift and so on
        !-----------------------------------------------------------------------------
        abundance=nucleus(1,4)
        isos=chemicalshift(1,2)+sr  ! isotropic chemical shift of s (in hz)
                                    ! modified by SR frequency
        etacs=chemicalshift(1,4)! csa assymetry of s
        csas=chemicalshift(1,3)/(3.0d0+etacs)! csa of s
        cqs=quadrupole(1,2)     ! cq of s
        etaqs=quadrupole(1,3)! etaq of s
        t2s=t2(1,2)! relaxation t2 of s
        do i=1,3
            csangle(i)=chemicalshift(1,4+i)
            qsangle(i)=quadrupole(1,3+i)
        end do
    else
        compute=.false.
        return
    endif

    ncoupled= size(nucleus,1)-1
    if (ncoupled.ge.1) then
        icoupled=1
        spini=nucleus(2,2)! spin of i
        vli=nucleus(2,3)! larmor of i
        if (spini.lt.eps.or.vli.lt.eps) then
            icoupled=0
            spini=0.0D0
            vli=0.0D0
        else
            isoi=chemicalshift(2,2)! isotropic chemical shift of i
            etaci=chemicalshift(2,4)! csa assymetry of i
            csai=chemicalshift(2,3)/(3.0d0+etaci)! csa of i
            cqi=quadrupole(2,2)! cq of i
            etaqi=quadrupole(2,3)! etaq of i
            t2i=t2(2,2)! relaxation t2 of i
            do i=1,3
                ciangle(i)=chemicalshift(2,4+i)
                qiangle(i)=quadrupole(2,3+i)
            end do
            ! the definition of j and d coupling is reported later
            jsi=0.0d0
            dsi=0.0d0
            dsiangle=0.0d0
        end if
    end if

    if (ncoupled.ge.2) then
        kcoupled=ncoupled-1
        allocate (spink(kcoupled))! spin of k
        allocate (vlk(kcoupled))! larmor of k
        allocate (jsk(kcoupled))! j s-k
        allocate (dsk(kcoupled))! dipolar s-k
        allocate (dskangle(kcoupled,3))! orientation of s-k dipole
        do i=1,kcoupled
            spink(i)=nucleus(i+2,2)
            vlk(i)=nucleus(i+2,3)
        end do
        jsk=0.0d0! these arrays will be set later
        dsk=0.0d0
        dskangle=0.0d0
    end if

    ! j coupling
    if (allocated(indirect)) then
        do i=1,size(indirect,1)
            ! remember or note that the first nucleus is s
            ! the second nucleus is i and the other are the k nuclei
            if ((nint(indirect(i,2)).eq.2).and.(icoupled.gt.0)) then
                ! then it is a j coupling between s and i
                jsi=indirect(i,3)
                ! the anisotropy of j is not yet implemented
                ! (even if the table can handle the definition of deltaj)
            end if
            if ((nint(indirect(i,2)).gt.2).and.(kcoupled.gt.0))  then
                ! in this case it is a j coupling between s and k
                jsk(nint(indirect(i,2))-2)=indirect(i,3)
            end if
        end do
    end if

    ! dipolar coupling
    if (allocated(dipole)) then
        do i=1,size(dipole,1)
            ! remember or note that the first nucleus is s
            ! the second nucleus is i and the other are the k nuclei
            if ((nint(dipole(i,2)).eq.2).and.(icoupled.gt.0)) then
                ! then it is a dipole coupling between s and i
                dsi=dipole(i,3)
                do j=1,3
                    dsiangle(j)=dipole(i,4+j)
                end do
            end if
            if ((dipole(i,2).gt.2).and.(kcoupled.gt.0))  then
                ! in this case it is a dipolar coupling between s and k
                dsk(nint(dipole(i,2))-2)=dipole(i,3)
                do j=1,3
                    dskangle(nint(dipole(i,2))-2,j)=dipole(i,4+j)
                end do
            end if
        end do
    end if

    ! spectrum limit
    fst=-sw/2.0d0! i think this can be changed later

    ! simulation parameters
    if (rfstep.lt.0.10d0) rfstep=0.1d0
    if (rfstep.gt.360.0d0) rfstep=360.0d0
    rpf=rotorperiod*rfstep/360.0d0! rpf: rotorperiod fraction in us
    qq=4.0d0*qfactor*qfactor/vls/vls

    do l=1,4
        wm(l)=dble(l)*spinningspeed
    end do

    ! detection: all=0, central=1, satellite=2
    if (nall.eq.999) nall=0
    if (spins<0.4) nall=1
    if (mod(spins,1.0d0).lt.0.001) nall=0 ! in the case of an integer spin s,
                                          !all transitions must be calculated

    ! define all operators
    call reset_operators()

    ! preparation pulses and delays
    allocate (rfpowers(ncycles))
    allocate (rfoffsets(ncycles))
    allocate (rfphases(ncycles))

    allocate (rfpoweri(ncycles))
    allocate (rfoffseti(ncycles))
    allocate (rfphasei(ncycles))

    allocate (rflength(ncycles))

    allocate (rfdelay(ncycles))
    allocate (decouple(ncycles))

    allocate (itour(ncycles))
    allocate (ntp(ncycles))
    allocate (deltatp(ncycles))
    allocate (ntpadd(ncycles))
    allocate (deltatpadd(ncycles))
    allocate (t2ss(ncycles))
    allocate (t2ii(ncycles))
    allocate (t2si(ncycles))

    do nc=1,ncycles
        rflength(nc)=pulse(nc,2)
        if (abs(rflength(nc)).le.eps) then
            idealpulse=.true.
        end if
        rfpowers(nc)=pulse(nc,3)
        rfoffsets(nc)=pulse(nc,4)
        rfphases(nc)=radians(pulse(nc,5))
        rfpoweri(nc)=pulse(nc,6)
        rfoffseti(nc)=pulse(nc,7)
        rfphasei(nc)=radians(pulse(nc,8))
        
        ! calculate the increment dtp for pulse effect integration
        itour(nc)=floor(rflength(nc)/rotorperiod)-1

        ! when the pulse length is less than one rotor period (itour=0),
        ! the pulse is divided in ntp intervals with duration dtp
        ! else each of the itour rotor period are divided in the same way
        ! in ntp intervals (duration deltatp)
        ! and the last period is divided in ntpadd intervals of the same duration,
        ! plus a small additional period dtpadd<deltatp

        ntp(nc)=min(rflength(nc),rotorperiod)/rpf+1
        deltatp(nc)=min(rflength(nc),rotorperiod)/dble(ntp(nc))
        !  i don't know why dtp doesnt work ... changed to deltatp
        !  probably a reserved keyword in f2py
        deltatpadd(nc)=0.0d0
        ntpadd(nc)=0
        if (itour(nc).ge.0) then
            ntpadd(nc)=floor( (rflength(nc)-dble(itour(nc)+1)*rotorperiod)/deltatp(nc) )
            deltatpadd(nc)=rflength(nc) &
                             -dble(itour(nc)+1)*rotorperiod-dble(ntpadd(nc))*deltatp(nc)
        end if

        rfdelay(nc)=delay(nc,2)
        t2ss(nc)=exp(-(rflength(nc)+rfdelay(nc))/t2s)
        t2ii(nc)=exp(-(rflength(nc)+rfdelay(nc))/t2i)
        t2si(nc)=(t2ss(nc)+t2ii(nc))/2.0d0
        
        ! decoupling !!!!!!!!!!!!!!!!!!!!!!!!!!!!!! To check !!!!!!!
        if(delay(nc,3)>.1d0) then
            ! warning when decouple = 1 this means no decoupling...
            decouple(nc)=1
        else
            decouple(nc)=0
        end if
    end do

    ! coefficients for the quadrupole
    coefps=0.0d0
    coefpi=0.0d0
    if(spins.gt.0.6) coefps=-0.5d0*sq6*cqs/(4.0d0*spins*(2.0d0*spins-1.0d0))
    if(spini.gt.0.6) coefpi=-0.5d0*sq6*cqi/(4.0d0*spini*(2.0d0*spini-1.0d0))
    coefss=6.0d0*coefps**2/vls
    coefsi=0.0D0
    if (icoupled>0) coefsi=6.0d0*coefpi**2/vli

    allocate(u1s(ns),u2s(ns))

    do k=1,ns-1
        dms=spins+1.0d0 - dble(k)
        u1s(k)=-0.50d0*coefss*(24.0d0*dms*(dms-1.0d0)-4.0d0*spins*(spins+1.0d0)+9.0d0)
        u2s(k)=-0.25d0*coefss*(12.0d0*dms*(dms-1.0d0)-4.0d0*spins*(spins+1.0d0)+6.0d0)
    end do

    ! tensor component of the dipolar tensor / quadrupole s
    ! (todo: change this to have a reference with respect to the molecular frame)

    r2mdsi=cmplx(0.0d0,0.0D0)
    if (icoupled>0) call orientate(-dsiangle,0.0d0,r2mdsi)
    ! the sign - before dsiangle depend on the definition choosen (euler or polar angle)

    ! quadrupole i / quadrupole s
    r2mqi=cmplx(0.0d0,0.0D0)
    if (icoupled>0) call orientate(qiangle,etaqi,r2mqi)

    ! csa s / quadrupole s
    r2mcs=cmplx(0.0d0,0.0D0)
    call orientate(csangle,etacs,r2mcs)

    ! csa i / quadrupole s
    r2mci=cmplx(0.0d0,0.0D0)
    if (icoupled>0) call orientate(ciangle,etaci,r2mci)

    ! other dipolar coupling with non-excited nuclei (k)
    coefdip=1.0d0
    if (kcoupled>0) then
        allocate(r2mdsk(kcoupled,0:2))
        allocate(nk(kcoupled))
        allocate (dipk(kcoupled))
        allocate (mk(kcoupled))
        dipk=0.0d0
        mk=0
        r2mdsk=cmplx(0.0d0,0.0D0)
        do k=1,kcoupled
            nk(k)=nint(2.0d0*spink(k))
            coefdip=coefdip/(2.0d0*spink(k)+1.0d0)
            tempr2m=cmplx(0.0d0,0.0d0)
            do j=0,2
                tempangle(j)=dskangle(k,j)
            end do
            call orientate(-tempangle,0.0d0,tempr2m)
            do j=0,2
                r2mdsk(k,j)=tempr2m(j)
            end do
        end do
    end if

    ! frequencies and amplitude
    allocate (wr(0:nt,0:2*nt,ns))
    wr=0.0d0

    allocate (amp(0:nt,0:2*nt,ns,-nsb:nsb))
    amp=cmplx(0.0d0,0.0D0)

    ! ll arrays
    ! they are allocated here to avoid the multiple allocation-deallocation in ll
    if (kcoupled>0) allocate (adks(kcoupled,-4:4))
    allocate (a(ns,4))
    a=0.0d0

    allocate (p(ns,-nsb:nsb))
    p=0.0d0

    allocate (u(nsi,nsi))
    u=0.0d0

    allocate (ui(nsi,nsi))
    ui=0.0d0
    allocate (uf(nsi,nsi))
    uf=0.0d0
    allocate (usi(nsi,nsi))
    usi=0.0d0
    allocate (usf(nsi,nsi))
    usf=0.0d0
    allocate (uint(nsi,nsi))
    uint=0.0d0
    allocate (ro(nsi,nsi))
    ro=0.0d0
    allocate (rot(nsi,nsi))
    rot=0.0d0
    allocate (z(nsi,nsi))
    z=0.0d0
    allocate (vp(nsi))
    vp=0.0d0
    allocate (expvp(nsi,nsi))
    expvp=0.0d0
    allocate (y(nsi,nsi))
    y=0.0d0
    allocate (htst(nsi,nsi))
    htst=0.0d0
    allocate (htsr(nsi,nsi))
    htsr=0.0d0
    allocate (sti(ni,ni))
    sti=0.0d0
    allocate (rosto(nsi,nsi))
    rosto=0.0d0
    allocate (q(ns,-nsb:nsb))
    q=0.0d0
    ! and the density matrix
    allocate (rott(nsi,nsi))! rortt and roitt
    rott=0.0d0

    ! allocate some other important arrays
    allocate (qt(0:nt,0:2*nt,ns,-nsb:nsb))
    qt=cmplx(0.0d0,0.0d0)

    ! spec will contain the simulated spectrum
    ! (if zerospectrum is false then it is not erased for addition of data)
    ! this is not used in masai TOSUPPRESS
    zerospectrum = .true.
    if (zerospectrum.and.allocated(spec)) then
        deallocate (spec)
        allocate (spec(npts))
        spec=cmplx(0.0d0,0.0d0)
        sumc = cmplx(0.0d0, 0.0d0)
        sums = cmplx(0.0d0, 0.0d0)
    end if
    if (.not.allocated(spec)) then
    	! in all case if it is not allocated, we have to allocate it
        allocate (spec(npts))
        spec=cmplx(0.0d0,0.0d0)
        sumc = cmplx(0.0d0, 0.0d0)
        sums = cmplx(0.0d0, 0.0d0)
    end if

    if (allocated(ros)) deallocate (ros)
    allocate (ros(ns,ns))! contains the density matrix of S
    ros=cmplx(0.0d0,0.0d0)

    if (allocated(roi)) deallocate (roi)
    allocate (roi(ni,ni))! contains the density matrix of I
    roi=cmplx(0.0d0,0.0d0)

    ! preparation for phase cycling or coherence pathway (CTP) selection
    ! up to now, only the CTP selection is implemented

    if (allocated(ctp)) then
        nctp=size(ctp,1)
    else
        nctp=1
    end if

    allocate (roctp(nctp,nsi,nsi))
    roctp=0.0d0

    if (keepgoing) then
        !------------------------------------------------------------------
        ! make the recursive loop on the various k to calculate the spectra
        call loop_on_k(1_8)
        !------------------------------------------------------------------
        ! Last normalisation to unity area
        if (mod(ns,2) .eq. 0) then
            spec = spec /sumc    ! norm to 1 with respect to the central transition
        else
            spec = spec /sums
            ! or with respect to the whole transition for integer spin
        end if
    else
        exception=10
        exception_text="user cancellation"
    end if

    ! make the density matrix of S
    ros=0.0d0
    do i=1,ns
        do j=1,ns
            do k=0,ni-1
                ros(i,j)=ros(i,j)+rott(i+k*ns,j+k*ns)
            end do
        end do
    end do
    ros=ros/dble(ni)/fnexp

    ! make the density matrix of I
    if (icoupled>0.and.ni.GE.2) then
        roi=0.0d0
        do i=1,ni
            do j=1,ni
                do k=1,ns
                    roi(i,j)=roi(i,j)+rott(k+(i-1)*ns,k+(j-1)*ns)
                end do
            end do
        end do
        roi=roi*vls/vli/dble(ns)/fnexp
    end if

    ! deallocate (important if there is a new call to 'compute' subroutine by python)
    !--------------------------------------------------------------------------------
    deallocate (rfpowers)
    deallocate (rfoffsets)
    deallocate (rfphases)

    deallocate (rfpoweri)
    deallocate (rfoffseti)
    deallocate (rfphasei)

    deallocate (rflength)

    deallocate (rfdelay)
    deallocate (decouple)

    deallocate (itour)
    deallocate (ntp)
    deallocate (deltatp)
    deallocate (ntpadd)
    deallocate (deltatpadd)
    deallocate (t2ss)
    deallocate (t2ii)
    deallocate (t2si)
    deallocate (u1s,u2s)

    if (kcoupled>0) then
        deallocate (r2mdsk)
        deallocate (nk)
        deallocate (dipk)
        deallocate (mk)
        deallocate (adks)
        deallocate (spink)
        deallocate (vlk)
        deallocate (jsk)
        deallocate (dsk)
        deallocate (dskangle)
    end if

    deallocate (wr)
    deallocate (amp)
    deallocate (a)
    deallocate (p)
    deallocate (u)
    deallocate (ui)
    deallocate (uf)
    deallocate (usi)
    deallocate (usf)
    deallocate (uint)
    deallocate (ro)
    deallocate (rot)
    deallocate (z)
    deallocate (vp)
    deallocate (expvp)
    deallocate (y)
    deallocate (htst)
    deallocate (htsr)
    deallocate (sti)
    deallocate (rosto)
    deallocate (q)
    deallocate (rott)
    deallocate (qt)
    deallocate (roctp)

    !computation complete
    compute=.true.
    return

    !internal functions and subroutines===========================================
    contains

        ! loop on k ================================================================
        recursive subroutine loop_on_k(ik)
        !---------------------------------
            implicit none

            integer*8 :: ik ! index of the nucleus k
            integer*8 :: jk
            integer*8 :: k

            if (ik > kcoupled) then
                ! we are in the innermost loop
                ! execute the remaining of the program

                ! calculation of the chemical shift for each transition
                isost=isos
                do k=1,kcoupled
                    isost=isost+jsk(k)*dble(mk(k))/2.0d0
                end do

                wholesphere=.false.
                wholesphere=(wholesphere.or.&
                (abs(csas)*(abs(csangle(1))+abs(csangle(2))+abs(csangle(3))).gt.eps))
                wholesphere=(wholesphere.or.&
                (abs(cqs)*(abs(qsangle(1))+abs(qsangle(2))+abs(qsangle(3))).gt.eps))
                if (icoupled>0) wholesphere=(wholesphere.or.&
                    (abs(cqi)*(abs(qiangle(1))+abs(qiangle(2))+abs(qiangle(3))).gt.eps))
                if (icoupled>0) wholesphere=(wholesphere.or. &
                    (abs(dsiangle(1))+abs(dsiangle(2))+abs(dsiangle(3))).gt.eps)
                if (icoupled>0) wholesphere=(wholesphere.or. &
                    (abs(csai)*(abs(ciangle(1))+abs(ciangle(2))+abs(ciangle(3))).gt.eps))
                do k=1, kcoupled
                    wholesphere=(wholesphere.or.((abs(mk(k))*abs(dskangle(k,1))+ &
                                        abs(mk(k))*abs(dskangle(k,2))+ &
                                        abs(mk(k))*abs(dskangle(k,3))).gt.eps))
                end do


                ! reset to zero
                qt=0.0d0 ! is-it necessary here?      (in the loop?)

                ! todo: loop on pulse phases if there is a phase cycling
                ! -----------------------------------------------------
                ! todo: create a recursive function to make these loops

                if(.not.wholesphere) then
                    dnorm=abundance*dble(nt)*coefdip/dble(ng)**2/dble(ns)/dble(nscans)
                    call edgea()
                else
                    dnorm=abundance*dble(nt)*coefdip/dble(ng)**2 &
                                                           /dble(ns)/dble(nscans)/4.0d0
                    call edgeb()
                end if

                ! end of phases loops

                ! compute the final powder spectra with various integration
                ! depending on the wholesphere flag
                ! ----------------------------------------------------------

                ! if only the averaged density matrix values are needed (intensities),
                ! we can bypass the next step:

                if(.not.wholesphere) then
                    fnexp=dble(ng*nscans)*powder1/coefdip
                    if (spectrum_compute) call spectrea()
                else
                    fnexp=dble(ng*nscans)*powder2/coefdip
                    if (spectrum_compute)  call spectreb()
                end if
                return
            end if

            ! recursive call to the subroutine
            !---------------------------------
            ! replace the nested loops on the differents nucleus
            ! programming hint:
            ! do not use index instead of jk, ik that are defined outside this function

            do jk=-nk(ik),nk(ik),2
                mk(ik)=jk
                dipk(ik)=dsk(ik)*dble(jk)/2.0d0
                call loop_on_k(ik+1)
            end do

        end subroutine loop_on_k
        ! end loop on k ============================================================

        ! edgeA ====================================================================
        subroutine edgea()
            !-----------------
            implicit none
            integer*8 :: jj,ii,cr
            real*8    :: r,r3,xi,yi,zi

            cr=0
            do jj=0,nt
                do ii=0,nt-jj
                    r=sqrt(dble((nt-ii-jj)**2+ii*ii+jj*jj))
                    r3=r*r*r
                    xi=dble(nt-ii-jj)/r
                    yi=dble(ii)/r
                    zi=dble(jj)/r
                    call ll(xi,yi,zi,ii,jj,r3)
                    cr=cr+1
                end do
            end do
        end subroutine edgea
        !===========================================================================

        !===========================================================================
        subroutine edgeb()
        !   -----------------
            implicit none
            integer*8 :: jj,ii,cr
            real*8    :: r,r3,xi,yi,zi
            integer*8 :: nsbs
            !
            cr=0
            do jj=0,nt-1
                do ii=0,nt-jj
                    r=sqrt(dble((nt-ii-jj)**2+ii*ii+jj*jj))
                    r3=r*r*r
                    xi=dble(nt-ii-jj)/r
                    yi=dble(ii)/r
                    zi=dble(jj)/r
                    call ll(xi,yi,zi,ii,jj,r3)
                    cr=cr+1
                end do
                do ii=nt-jj+1,nt
                    r=sqrt(dble((nt-ii-jj)**2+(nt-jj)**2+(nt-ii)**2))
                    r3=r*r*r
                    xi=dble(nt-ii-jj)/r
                    yi=dble(nt-jj)/r
                    zi=dble(nt-ii)/r
                    call ll(xi,yi,zi,ii,jj,r3)
                    cr=cr+1
                end do
            end do
            !
            do jj=nt,2*nt-1
                do ii=jj-nt+1,nt-1
                    r=sqrt(dble((jj-nt-ii)**2+(nt-jj)**2+(nt-ii)**2))
                    r3=r*r*r
                    xi=dble(jj-nt-ii)/r
                    yi=dble(nt-jj)/r
                    zi=dble(nt-ii)/r
                    call ll(xi,yi,zi,ii,jj,r3)
                    cr=cr+1
                end do
                do ii=1,jj-nt
                    r=sqrt(dble((jj-nt-ii)**2+ii*ii+(2*nt-jj)**2))
                    r3=r*r*r
                    xi=dble(jj-nt-ii)/r
                    yi=-dble(ii)/r
                    zi=dble(2*nt-jj)/r
                    call ll(xi,yi,zi,ii,jj,r3)
                    cr=cr+1
                end do
            end do
            !
            do k=1,ns-1
                do jj=0,nt-1
                    wr(0,2*nt-jj,k)=wr(0,jj,k)
                    do nsbs=-nsb,nsb
                        amp(0,2*nt-jj,k,nsbs)=amp(0,jj,k,nsbs)
                    end do
                end do
                do ii=0,nt
                    wr(nt,nt+ii,k)=wr(ii,0,k)
                    do nsbs=-nsb,nsb
                        amp(nt,nt+ii,k,nsbs)=amp(ii,0,k,nsbs)
                    end do
                end do
                do jj=1,nt-1
                    wr(nt-jj,2*nt,k)=wr(nt,jj,k)
                    do nsbs=-nsb,nsb
                        amp(nt-jj,2*nt,k,nsbs)=amp(nt,jj,k,nsbs)
                    end do
                end do
            end do
            !
            r3=dble(nt*nt*nt)
            call ll(0.0d0,0.0d0,1.0d0,0_8,nt,r3)
            !
        end subroutine edgeb
        !===========================================================================

        !===========================================================================
        subroutine spectrea()
            !   --------------------
            implicit none
            integer*8 :: nsbs
            real*8 :: decal
            complex*8 :: ampt

            do k=1,ns-1
                !
                if(nall.eq.1.and.(2*k).ne.ns) cycle
                if(nall.eq.2.and.(2*k).eq.ns) cycle
                !
                do nsbs=-nsb,nsb
                    decal=nsbs*spinningspeed
                    do i=0,nt-2
                        do j=0,nt-2-i
                            ampt=amp(i+1,j,k,nsbs)+amp(i,j+1,k,nsbs)+amp(i,j,k,nsbs)
                            if ((2*k).eq.ns) then
                                sumc = sumc + ampt
                            else
                                sums = sums + ampt
                            end if
                            call tent(wr(i+1,j,k),wr(i,j+1,k),wr(i,j,k),ampt,decal)
                            ampt=amp(i+1,j,k,nsbs)+amp(i,j+1,k,nsbs)+amp(i+1,j+1,k,nsbs)
                            if ((2*k).eq.ns) then
                                sumc = sumc + ampt
                            else
                                sums = sums + ampt
                            end if
                            call tent(wr(i+1,j,k),wr(i,j+1,k),wr(i+1,j+1,k),ampt,decal)
                        end do
                    end do
                    do i=0,nt-1
                        j=nt-1-i
                        ampt=amp(i+1,j,k,nsbs)+amp(i,j+1,k,nsbs)+amp(i,j,k,nsbs)
                        if ((2*k).eq.ns) then
                            sumc = sumc + ampt
                        else
                            sums = sums + ampt
                        end if
                        call tent(wr(i+1,j,k),wr(i,j+1,k),wr(i,j,k),ampt,decal)
                    end do
                end do
            end do
        end subroutine spectrea
        !===========================================================================

        !===========================================================================
        subroutine spectreb()
        !   --------------------
            implicit none
            !
            integer*8 :: nsbs
            real*8 :: decal
            complex*8 :: ampt
            !
            do k=1,ns-1
                !
                if(nall.eq.1.and.(2*k).ne.ns) cycle
                if(nall.eq.2.and.(2*k).eq.ns) cycle
                !
                do nsbs=-nsb,nsb
                    decal=nsbs*spinningspeed
                    do i=0,nt-1
                        do j=0,nt-1
                            ampt=amp(i+1,j,k,nsbs)+amp(i,j+1,k,nsbs)+amp(i,j,k,nsbs)
                            if ((2*k).eq.ns) then
                                sumc = sumc + ampt
                            else
                                sums = sums + ampt
                            end if
                            call tent(wr(i+1,j,k),wr(i,j+1,k),wr(i,j,k),ampt,decal)
                            ampt=amp(i+1,j,k,nsbs)+amp(i,j+1,k,nsbs)+amp(i+1,j+1,k,nsbs)
                            if ((2*k).eq.ns) then
                                sumc = sumc + ampt
                            else
                                sums = sums + ampt
                            end if
                            call tent(wr(i+1,j,k),wr(i,j+1,k),wr(i+1,j+1,k),ampt,decal)
                        end do
                        do  j=nt,2*nt-1
                            ampt=amp(i,j,k,nsbs)+amp(i+1,j+1,k,nsbs)+amp(i+1,j,k,nsbs)
                            if ((2*k).eq.ns) then
                                sumc = sumc + ampt
                            else
                                sums = sums + ampt
                            end if
                            call tent(wr(i,j,k),wr(i+1,j+1,k),wr(i+1,j,k),ampt,decal)
                            ampt=amp(i,j,k,nsbs)+amp(i+1,j+1,k,nsbs)+amp(i,j+1,k,nsbs)
                            if ((2*k).eq.ns) then
                                sumc = sumc + ampt
                            else
                                sums = sums + ampt
                            end if
                            call tent(wr(i,j,k),wr(i+1,j+1,k),wr(i,j+1,k),ampt,decal)
                        end do
                    end do
                end do
            end do
        end subroutine spectreb
        !===========================================================================

        !===========================================================================
        subroutine tent(w1,w2,w3,amplitude,shift)
            !   ----------------------------------------
            !   todo: - rewrite to suppress gotos and labels
            implicit none
            real*8, intent(in) :: w1
            real*8, intent(in) :: w2
            real*8, intent(in) :: w3
            complex*8, intent(in) :: amplitude
            real*8, intent(in) :: shift
            real*8 :: finc
            real*8 :: ff1
            real*8 :: ff2
            real*8 :: ff3
            real*8 :: fmin
            real*8 :: fmid
            real*8 :: fmax
            real*8 :: fdn
            real*8 :: fxd
            real*8 :: fmn
            complex*8 :: top
            integer*8 :: np
            integer*8 :: npmid
            integer*8 :: npmax
            real*8 :: f1
            real*8 :: f2
            finc=sw/dble(npts-1)
            ff1=max(w1,w2)
            ff2=max(w2,w3)
            ff3=max(w3,w1)
            fmin=min(w1,w2,w3)+shift
            fmid=min(ff1,ff2,ff3)+shift
            fmax=max(w1,w2,w3)+shift
            fdn=fmid-fmin+0.0000001d0
            fxd=fmax-fmid+0.0000001d0
            fmn=fmax-fmin+0.0000001d0
            top=amplitude/fmn
            np=int((fmin-fst)/finc)+1
            npmid=int((fmid-fst)/finc)+1
            npmax=int((fmax-fst)/finc)+1
            if(npmax.gt.npts.or.np.lt.1) goto 80
            if(np.ne.npmid) goto 10
            spec(np)=spec(np)+fdn*top
            goto 40
        10  f2=finc*dble(np)+fst
            spec(np)=spec(np)+(f2-fmin)**2*top/fdn
        20  np=np+1
            f1=f2
            if(np.eq.npmid) goto 30
            f2=finc*dble(np)+fst
            spec(np)=spec(np)+finc*(f2+f1-2.0d0*fmin)*top/fdn
            goto 20
        30  spec(np)=spec(np)+(fmid-f1)*(fdn+f1-fmin)*top/fdn
        40  if(np.ne.npmax) goto 50
            spec(np)=spec(np)+fxd*top
            goto 80
        50  f2=finc*dble(npmid)+fst
            spec(np)=spec(np)+(f2-fmid)*(fmax-f2+fxd)*top/fxd
        60  np=np+1
            f1=f2
            if(np.eq.npmax) goto 70
            f2=finc*dble(np)+fst
            spec(np)=spec(np)+finc*(2.0d0*fmax-f1-f2)*top/fxd
            goto 60
        70  spec(np)=spec(np)+(fmax-f1)**2*top/fxd
        80  continue
        end subroutine tent
        !=================================================================================
    !end contains
end function compute
!=========================================================================================

!===============================================================================
! pulsar.share
!===============================================================================
! Copyright (C) 2006-2013 Christian Fernandez, Jean-Paul Amoureux
! JPA - Unite de Catalyse et Chimie du Solide, Lille, France.
! CF  - Laboratoire Catalyse et Spectrochimie, Caen, France.  
!       christian.fernandez@ensicaen.fr
! This software is governed by the CeCILL-B license under French law 
! and abiding by the rules of distribution of free software.  
! You can  use, modify and/ or redistribute the software under 
! the terms of the CeCILL-B license as circulated by CEA, CNRS and INRIA
! at the following URL "http://www.cecill.info".
! See Licence.txt in the main masai source directory
!===============================================================================


!------------------------
MODULE share
!------------------------
! other shared parameters
!------------------------
  use parameters

  integer*8 :: nt=-1
  integer*8 :: ng=-1
  logical*2 :: staticsample=.false.              ! (replace ispeed in the original version)
  real*8    :: dg=eps

  real*8    :: de(-4:4,-4:4)=eps                 ! wigner matrix
  real*8    :: dk(2,0:4,-2:2)=eps                !

  real*8    :: spins=eps                         ! spin i
  real*8    :: spini=eps                         ! spin s

  real*8    :: vls=eps                           ! larmor of spin s
  real*8    :: cqs=eps
  real*8    :: abundance=1.0d0
  real*8    :: etaqs=eps
  real*8    :: isos=eps
  real*8    :: csas=eps
  real*8    :: etacs=eps
  real*8    :: t2s=eps
  real*8    :: qq=eps                            ! effect of quality factor
  real*8    :: wm(4)=eps
  real*8    :: fst=eps
  integer*8 :: icoupled=-1                       ! if i exist
  real*8    :: vli=eps                           ! larmor of spin i
  real*8    :: cqi=eps
  real*8    :: etaqi=eps
  real*8    :: isoi=eps
  real*8    :: csai=eps
  real*8    :: etaci=eps
  real*8    :: t2i=eps
  real*8    :: jsi=eps                           ! j coupling between s and i
  real*8    :: dsi=eps                           ! dipolar coupling i-s
  integer*8 :: kcoupled=-1                       ! number of coupled k nucleus to s
  real*8    :: coefps=eps
  real*8    :: coefpi=eps
  real*8    :: coefss=eps
  real*8    :: coefsi=eps
  real*8    :: isost=eps

  complex*8 :: r2mdsi(0:2)                       ! r2m component for is dipolar tensor
  complex*8 :: r2mqi(0:2)
  complex*8 :: r2mcs(0:2)
  complex*8 :: r2mci(0:2)

  integer*8 :: ns=-1
  integer*8 :: ni=-1
  integer*8 :: nsi=-1
  real*8    :: fnexp=eps

  real*8 :: vvi(2)
  real*8 :: vvs(2)
  real*8 :: vvii(2)
  real*8 :: vvis(2)
  complex*8 :: ats(-4:4)                   ! arts and aits
  complex*8 :: aqs(-4:4)                  ! arqs(10,-4:4) and aiqs(10,-4:4)
  complex*8 :: acs(-4:4)                  ! arcs and aics
  complex*8 :: ads(-4:4)                     ! ads(4,:) correspondant  dipolaire i-s
  complex*8 :: aqi(-4:4)                     ! arqi and aiqi
  complex*8 :: aci(-4:4)                     ! arci and aici
  complex*8 :: aqpi(0:4)
  complex*8 :: aqps(0:4)
  complex*8 :: adcps(0:4)
  complex*8 :: aqsi(2,0:4)
  complex*8 :: aqss(2,0:4)
  complex*8 :: acspi(0:4)
  complex*8 :: adipolis(0:4)

  real*8 :: zl(0:4)=(/1.0d0,2.0d0,2.0d0,2.0d0,2.0d0/)

  real*8    :: qsangle(3)
  real*8    :: csangle(3)
  real*8    :: qiangle(3)
  real*8    :: ciangle(3)
  real*8    :: dsiangle(3)                   ! dipolar orientation

  real*8, dimension(:), allocatable :: spink              ! non -excited and non-observed nuclei
  real*8, dimension(:), allocatable :: vlk                ! larmor of spins k
  real*8, dimension(:), allocatable :: jsk                ! j coupling between s-k
  real*8, dimension(:), allocatable :: dsk                ! dipolar coupling s-k
  real*8, dimension(:,:), allocatable :: dskangle         ! dipolar orientation of s-k

  real*8, dimension(:), allocatable :: rfpowers 
  real*8, dimension(:), allocatable :: rfoffsets 
  real*8, dimension(:), allocatable :: rfphases 
  real*8, dimension(:), allocatable :: rfpoweri 
  real*8, dimension(:), allocatable :: rfoffseti 
  real*8, dimension(:), allocatable :: rfphasei 
  real*8, dimension(:), allocatable :: rflength 
  real*8, dimension(:), allocatable :: rfdelay 
  integer*8, dimension(:), allocatable :: decouple 

  integer*8, dimension(:), allocatable :: itour 
  integer*8, dimension(:), allocatable :: ntp 
  real*8, dimension(:), allocatable :: deltatp 
  integer*8, dimension(:), allocatable :: ntpadd 
  real*8, dimension(:), allocatable :: deltatpadd 
  real*8, dimension(:), allocatable :: t2ss 
  real*8, dimension(:), allocatable :: t2ii 
  real*8, dimension(:), allocatable :: t2si 

  complex*8, dimension(:,:), allocatable :: rott             ! rortt and roitt
  complex*8, dimension(:,:,:,:), allocatable :: qt           ! qrt and qit(0:40,0:80,11,-20:20)

  real*8, dimension(:), allocatable :: u1s 
  real*8, dimension(:), allocatable :: u2s 

  complex*8, dimension(:,:), allocatable :: r2mdsk           ! tensor components ks
  integer*8, dimension(:), allocatable :: nk 

  real*8, dimension(:), allocatable :: dipk 
  integer*8, dimension(:), allocatable :: mk 

  real*8, dimension(:,:,:), allocatable :: wr 
  complex*8, dimension(:,:,:,:), allocatable :: amp 
  real*8                 :: dnorm=eps


  complex*8, dimension(:,:), allocatable :: adks             ! ards and aids   correspondant au dipolaire k-s
  complex*8, dimension(:,:), allocatable :: a                ! ab(11,4),bb(11,4)
  complex*8, dimension(:,:), allocatable :: p                ! pr(11,-20:20) and pi(11,-20:20)
  complex*8, dimension(:,:), allocatable :: u                ! tr and ti
  complex*8, dimension(:,:), allocatable :: ui               ! tri(100,100),tii(100,100)
  complex*8, dimension(:,:), allocatable :: uf               ! trf(100,100),tif(100,100)
  complex*8, dimension(:,:), allocatable :: usi              ! trsi(100,100),tisi(100,100)
  complex*8, dimension(:,:), allocatable :: usf              ! trsf(100,100),tisf(100,100)
  complex*8, dimension(:,:), allocatable :: uint             ! trint(100,100),tiint(100,100)
  complex*8, dimension(:,:), allocatable :: ro               ! ror and roi
  complex*8, dimension(:,:), allocatable :: rot              ! rotr and roti
  complex*8, dimension(:,:), allocatable :: y                ! yr and yi
  complex*8, dimension(:,:), allocatable :: htst             ! htsrt(100,100) and htsit(100,100)
  complex*8, dimension(:,:), allocatable :: z                ! zr and zi
  real*8, dimension(:), allocatable :: vp 
  complex*8, dimension(:,:), allocatable :: expvp            ! exp(ivp)
  real*8, dimension(:,:), allocatable :: htsr             ! htsr(100,100)
  complex*8, dimension(:,:), allocatable :: sti              ! stri(11,11),stii(11,11)
  complex*8, dimension(:,:), allocatable :: rosto            !
  complex*8, dimension(:,:), allocatable :: q                ! qr(11,-20:20) and qi(11,-20:20)
  real*8, dimension(:), allocatable :: phasei 

  COMPLEX*8, dimension(:,:,:), allocatable :: roctp 
  integer*8 :: nctp=-1

  integer*8 :: STOPPED=-1

  complex*8 :: sumc
  complex*8 :: sums


END MODULE share

!-----------------------
subroutine reset_share()
!-----------------------

use share

      nt=-1
      ng=-1
      staticsample=.false.              ! (replace ispeed in the original version)
      dg=eps
      de=eps                            ! wigner matrix
      dk=eps                            !
      spins=eps                         ! spin i
      spini=eps                         ! spin s

      vls=eps                           ! larmor of spin s
      cqs=eps
      sigmaqs = eps
      abundance=1.0d0
      etaqs=eps
      isos=eps
      csas=eps
      etacs=eps
      t2s=eps
      qq=eps                            ! effect of quality factor
      wm=eps
      fst=eps
      icoupled=-1                       ! if i exist
      vli=eps                           ! larmor of spin i
      cqi=eps
      sigmaqi = eps
      etaqi=eps
      isoi=eps
      csai=eps
      etaci=eps
      t2i=eps
      jsi=eps                           ! j coupling between s and i
      dsi=eps                           ! dipolar coupling i-s
      kcoupled=-1                       ! number of coupled k nucleus to s
      coefps=eps
      coefpi=eps
      coefss=eps
      coefsi=eps
      isost=eps

      sumc = cmplx(0.0d0,0.0d0)
      sums = cmplx(0.0d0,0.0d0)



      r2mdsi=cmplx(0.0d0,0.0d0)                       ! r2m component for is dipolar tensor
      r2mqi=cmplx(0.0d0,0.0d0)
      r2mcs=cmplx(0.0d0,0.0d0)
      r2mci=cmplx(0.0d0,0.0d0)

      ns=-1
      ni=-1
      nsi=-1
      fnexp=eps

      vvi=0.0d0
      vvs=0.0d0
      vvii=0.0d0
      vvis=0.0D0
      ats=cmplx(0.0d0,0.0d0)                   ! arts and aits
      aqs=cmplx(0.0d0,0.0d0)                  ! arqs(10,-4:4) and aiqs(10,-4:4)
      acs=cmplx(0.0d0,0.0d0)                  ! arcs and aics
      ads=cmplx(0.0d0,0.0d0)                     ! ads(4,:) correspondant  dipolaire i-s
      aqi=cmplx(0.0d0,0.0d0)                     ! arqi and aiqi
      aci=cmplx(0.0d0,0.0d0)                     ! arci and aici
      aqpi=cmplx(0.0d0,0.0d0)
      aqps=cmplx(0.0d0,0.0d0)
      adcps=cmplx(0.0d0,0.0d0)
      aqsi=cmplx(0.0d0,0.0d0)
      aqss=cmplx(0.0d0,0.0d0)
      acspi=cmplx(0.0d0,0.0d0)
      adipolis=cmplx(0.0d0,0.0d0)

      zl(0:4)=(/1.0d0,2.0d0,2.0d0,2.0d0,2.0d0/)

      qsangle=0.0d0
      csangle=0.0d0
      qiangle=0.0d0
      ciangle=0.0d0
      dsiangle=0.0d0

      if (allocated(spink)) deallocate (spink)
      if (allocated(vlk)) deallocate (vlk)
      if (allocated(jsk)) deallocate (jsk)
      if (allocated(dsk)) deallocate (dsk)
      if (allocated(dskangle)) deallocate (dskangle)

      if (allocated(rfpowers)) deallocate (rfpowers)
      if (allocated(rfoffsets)) deallocate (rfoffsets)
      if (allocated(rfphases)) deallocate (rfphases)
      if (allocated(rfpoweri)) deallocate (rfpoweri)
      if (allocated(rfoffseti)) deallocate (rfoffseti)
      if (allocated(rfphasei)) deallocate (rfphasei)
      if (allocated(rflength)) deallocate (rflength)
      if (allocated(rfdelay)) deallocate (rfdelay)
      if (allocated(decouple)) deallocate (decouple)

      if (allocated(itour)) deallocate (itour)
      if (allocated(ntp)) deallocate (ntp)
      if (allocated(deltatp)) deallocate (deltatp)
      if (allocated(ntpadd)) deallocate (ntpadd)
      if (allocated(deltatpadd)) deallocate (deltatpadd)
      if (allocated(t2ss)) deallocate (t2ss)
      if (allocated(t2ii)) deallocate (t2ii)
      if (allocated(t2si)) deallocate (t2si)

      if (allocated(rott)) deallocate(rott)
      if (allocated(qt)) deallocate (qt)

      if (allocated(u1s)) deallocate (u1s)
      if (allocated(u2s)) deallocate (u2s)

      if (allocated(r2mdsk)) deallocate (r2mdsk)          ! tensor components ks
      if (allocated(nk)) deallocate (nk)

      if (allocated(dipk)) deallocate(dipk)
      if (allocated(mk)) deallocate(mk)

      if (allocated(wr)) deallocate (wr)
      if (allocated(amp)) deallocate (amp)
      dnorm=0.0d0


      if (allocated(adks)) deallocate (adks)
      if (allocated(a)) deallocate (a)
      if (allocated(p)) deallocate (p)
      if (allocated(u)) deallocate (u)
      if (allocated(ui)) deallocate (ui)
      if (allocated(uf)) deallocate (uf)
      if (allocated(usi)) deallocate (usi)
      if (allocated(usf)) deallocate (usf)
      if (allocated(uint)) deallocate (uint)
      if (allocated(ro)) deallocate (ro)
      if (allocated(rot)) deallocate (rot)
      if (allocated(y)) deallocate (y)
      if (allocated(htst)) deallocate (htst)
      if (allocated(z)) deallocate (z)
      if (allocated(vp)) deallocate (vp)
      if (allocated( expvp)) deallocate (expvp)
      if (allocated(htsr)) deallocate (htsr)
      if (allocated(sti)) deallocate (sti)
      if (allocated(rosto)) deallocate (rosto)
      if (allocated(q)) deallocate (q)
      if (allocated(phasei)) deallocate (phasei)
      if (allocated(roctp)) deallocate(roctp)
      nctp=-1

END subroutine

!     -*- f90 -*-
!     This file is autogenerated with f2py (version:2)
!     It contains Fortran 90 wrappers to fortran functions.

      subroutine f2py_parameters_getdims_roi(r,s,f2pysetdata,flag)
      use parameters, only: d => roi

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_roi
      subroutine f2py_parameters_getdims_t2(r,s,f2pysetdata,flag)
      use parameters, only: d => t2

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_t2
      subroutine f2py_parameters_getdims_pulse(r,s,f2pysetdata,flag)
      use parameters, only: d => pulse

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_pulse
      subroutine f2py_parameters_getdims_ros(r,s,f2pysetdata,flag)
      use parameters, only: d => ros

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_ros
      subroutine f2py_parameters_getdims_nphase(r,s,f2pysetdata,flag)
      use parameters, only: d => nphase

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_nphase
      subroutine f2py_parameters_getdims_dipole(r,s,f2pysetdata,flag)
      use parameters, only: d => dipole

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_dipole
      subroutine f2py_parameters_getdims_pulseangle(r,s,f2pysetdata,flag&
     &)
      use parameters, only: d => pulseangle

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_pulseangle
      subroutine f2py_parameters_getdims_delay(r,s,f2pysetdata,flag)
      use parameters, only: d => delay

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_delay
      subroutine f2py_parameters_getdims_quadrupole(r,s,f2pysetdata,flag&
     &)
      use parameters, only: d => quadrupole

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_quadrupole
      subroutine f2py_parameters_getdims_qu2(r,s,f2pysetdata,flag)
      use parameters, only: d => qu2

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_qu2
      subroutine f2py_parameters_getdims_spec(r,s,f2pysetdata,flag)
      use parameters, only: d => spec

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_spec
      subroutine f2py_parameters_getdims_indirect(r,s,f2pysetdata,flag)
      use parameters, only: d => indirect

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_indirect
      subroutine f2py_parameters_getdims_nucleus(r,s,f2pysetdata,flag)
      use parameters, only: d => nucleus

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_nucleus
      subroutine f2py_parameters_getdims_iref(r,s,f2pysetdata,flag)
      use parameters, only: d => iref

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_iref
      subroutine f2py_parameters_getdims_chemicalshift(r,s,f2pysetdata,f&
     &lag)
      use parameters, only: d => chemicalshift

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_chemicalshift
      subroutine f2py_parameters_getdims_ctp(r,s,f2pysetdata,flag)
      use parameters, only: d => ctp

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_ctp
      subroutine f2py_parameters_getdims_level(r,s,f2pysetdata,flag)
      use parameters, only: d => level

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_level
      subroutine f2py_parameters_getdims_qu1(r,s,f2pysetdata,flag)
      use parameters, only: d => qu1

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_qu1
      subroutine f2py_parameters_getdims_coher(r,s,f2pysetdata,flag)
      use parameters, only: d => coher

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(4) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_parameters_getdims_coher
      
      subroutine f2pyinitparameters(f2pysetupfunc)
      use parameters, only : ifasing
      use parameters, only : roi
      use parameters, only : twopi
      use parameters, only : qfactor
      use parameters, only : verbose
      use parameters, only : t2
      use parameters, only : nsb
      use parameters, only : sq6
      use parameters, only : pulse
      use parameters, only : accuracymax
      use parameters, only : keepgoing
      use parameters, only : warning
      use parameters, only : tab
      use parameters, only : twopim6
      use parameters, only : message
      use parameters, only : ros
      use parameters, only : nphase
      use parameters, only : rfstep
      use parameters, only : ncycles
      use parameters, only : exception_text
      use parameters, only : dipole
      use parameters, only : pulseangle
      use parameters, only : nall
      use parameters, only : delay
      use parameters, only : quadrupole
      use parameters, only : critical
      use parameters, only : qu2
      use parameters, only : message_fmt
      use parameters, only : pi
      use parameters, only : spec
      use parameters, only : accuracy
      use parameters, only : idealpulse
      use parameters, only : zerospectrum
      use parameters, only : spinningspeed
      use parameters, only : indirect
      use parameters, only : rcph
      use parameters, only : error
      use parameters, only : nucleus
      use parameters, only : crlf
      use parameters, only : iref
      use parameters, only : chemicalshift
      use parameters, only : spectrometerfield
      use parameters, only : underline
      use parameters, only : info
      use parameters, only : exception
      use parameters, only : spectrum_compute
      use parameters, only : ctp
      use parameters, only : level
      use parameters, only : protonfrequency
      use parameters, only : sr
      use parameters, only : sw
      use parameters, only : eps
      use parameters, only : qu1
      use parameters, only : loglevel
      use parameters, only : nptsmax
      use parameters, only : coher
      use parameters, only : czjzek
      use parameters, only : debug
      use parameters, only : npts
      use parameters, only : spinningangle
      use parameters, only : nboucle
      external f2pysetupfunc
      external f2py_parameters_getdims_roi
      external f2py_parameters_getdims_t2
      external f2py_parameters_getdims_pulse
      external f2py_parameters_getdims_ros
      external f2py_parameters_getdims_nphase
      external f2py_parameters_getdims_dipole
      external f2py_parameters_getdims_pulseangle
      external f2py_parameters_getdims_delay
      external f2py_parameters_getdims_quadrupole
      external f2py_parameters_getdims_qu2
      external f2py_parameters_getdims_spec
      external f2py_parameters_getdims_indirect
      external f2py_parameters_getdims_nucleus
      external f2py_parameters_getdims_iref
      external f2py_parameters_getdims_chemicalshift
      external f2py_parameters_getdims_ctp
      external f2py_parameters_getdims_level
      external f2py_parameters_getdims_qu1
      external f2py_parameters_getdims_coher
      call f2pysetupfunc(ifasing,f2py_parameters_getdims_roi,twopi,qfact&
     &or,verbose,f2py_parameters_getdims_t2,nsb,sq6,f2py_parameters_getd&
     &ims_pulse,accuracymax,keepgoing,warning,tab,twopim6,message,f2py_p&
     &arameters_getdims_ros,f2py_parameters_getdims_nphase,rfstep,ncycle&
     &s,exception_text,f2py_parameters_getdims_dipole,f2py_parameters_ge&
     &tdims_pulseangle,nall,f2py_parameters_getdims_delay,f2py_parameter&
     &s_getdims_quadrupole,critical,f2py_parameters_getdims_qu2,message_&
     &fmt,pi,f2py_parameters_getdims_spec,accuracy,idealpulse,zerospectr&
     &um,spinningspeed,f2py_parameters_getdims_indirect,rcph,error,f2py_&
     &parameters_getdims_nucleus,crlf,f2py_parameters_getdims_iref,f2py_&
     &parameters_getdims_chemicalshift,spectrometerfield,underline,info,&
     &exception,spectrum_compute,f2py_parameters_getdims_ctp,f2py_parame&
     &ters_getdims_level,protonfrequency,sr,sw,eps,f2py_parameters_getdi&
     &ms_qu1,loglevel,nptsmax,f2py_parameters_getdims_coher,czjzek,debug&
     &,npts,spinningangle,nboucle)
      end subroutine f2pyinitparameters
